/* App.c generated by valac 0.56.14, the Vala compiler
 * generated from App.vala, do not modify */

/*
* Copyright 2020 elementary, Inc. (https://elementary.io)
*           2020 Martin Abente Lahaye
*           2021 Justin Haygood (jhaygood86@gmail.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/

#include "applications.h"
#include <flatpak.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>

#define PERMISSIONS_BACKEND_APP_GROUP "Context"

enum  {
	PERMISSIONS_BACKEND_APP_0_PROPERTY,
	PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY,
	PERMISSIONS_BACKEND_APP_ID_PROPERTY,
	PERMISSIONS_BACKEND_APP_NAME_PROPERTY,
	PERMISSIONS_BACKEND_APP_NUM_PROPERTIES
};
static GParamSpec* permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

struct _PermissionsBackendAppPrivate {
	FlatpakInstalledRef* _installed_ref;
	gchar* _id;
	gchar* _name;
};

struct _Block4Data {
	int _ref_count_;
	PermissionsBackendApp* self;
	GPtrArray* permissions;
	GPtrArray* current_permissions;
};

static gint PermissionsBackendApp_private_offset;
static gpointer permissions_backend_app_parent_class = NULL;

static gchar* permissions_backend_app_get_overrides_path (PermissionsBackendApp* self);
static gboolean permissions_backend_app_is_permission_overridden (PermissionsBackendApp* self,
                                                           GPtrArray* overrides,
                                                           const gchar* permission);
static GPtrArray* permissions_backend_app_get_permissions_for_keyfile (PermissionsBackendApp* self,
                                                                GKeyFile* key_file);
static void _g_free0_ (gpointer var);
static void permissions_backend_app_set_id (PermissionsBackendApp* self,
                                     const gchar* value);
static void permissions_backend_app_set_name (PermissionsBackendApp* self,
                                       const gchar* value);
static GObject * permissions_backend_app_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static void _permissions_backend_app___lambda15_ (Block4Data* _data4_,
                                           const gchar* key);
static void __permissions_backend_app___lambda15__gh_func (gconstpointer key,
                                                    gconstpointer value,
                                                    gpointer self);
static void _permissions_backend_app_save_overrides_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void permissions_backend_app_finalize (GObject * obj);
static GType permissions_backend_app_get_type_once (void);
static void _vala_permissions_backend_app_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_permissions_backend_app_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
permissions_backend_app_get_instance_private (PermissionsBackendApp* self)
{
	return G_STRUCT_MEMBER_P (self, PermissionsBackendApp_private_offset);
}

PermissionsBackendApp*
permissions_backend_app_construct (GType object_type,
                                   FlatpakInstalledRef* installed_ref)
{
	PermissionsBackendApp * self = NULL;
#line 32 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (installed_ref != NULL, NULL);
#line 33 "../src/Permissions/Backend/App.vala"
	self = (PermissionsBackendApp*) g_object_new (object_type, "installed-ref", installed_ref, NULL);
#line 32 "../src/Permissions/Backend/App.vala"
	return self;
#line 132 "App.c"
}

PermissionsBackendApp*
permissions_backend_app_new (FlatpakInstalledRef* installed_ref)
{
#line 32 "../src/Permissions/Backend/App.vala"
	return permissions_backend_app_construct (PERMISSIONS_BACKEND_TYPE_APP, installed_ref);
#line 140 "App.c"
}

static gchar*
permissions_backend_app_get_overrides_path (PermissionsBackendApp* self)
{
	gchar* overrides_folder_path = NULL;
	PermissionsBackendFlatpakManager* _tmp0_;
	PermissionsBackendFlatpakManager* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* overrides_folder = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 122 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "../src/Permissions/Backend/App.vala"
	_tmp0_ = permissions_backend_flatpak_manager_get_default ();
#line 123 "../src/Permissions/Backend/App.vala"
	_tmp1_ = _tmp0_;
#line 123 "../src/Permissions/Backend/App.vala"
	_tmp2_ = permissions_backend_flatpak_manager_get_user_installation_path (_tmp1_);
#line 123 "../src/Permissions/Backend/App.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/Permissions/Backend/App.vala"
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp3_, "overrides", NULL);
#line 123 "../src/Permissions/Backend/App.vala"
	_tmp5_ = _tmp4_;
#line 123 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (_tmp1_);
#line 123 "../src/Permissions/Backend/App.vala"
	overrides_folder_path = _tmp5_;
#line 129 "../src/Permissions/Backend/App.vala"
	_tmp6_ = overrides_folder_path;
#line 129 "../src/Permissions/Backend/App.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 129 "../src/Permissions/Backend/App.vala"
	overrides_folder = _tmp7_;
#line 130 "../src/Permissions/Backend/App.vala"
	_tmp8_ = overrides_folder;
#line 130 "../src/Permissions/Backend/App.vala"
	if (!g_file_query_exists (_tmp8_, NULL)) {
#line 190 "App.c"
		{
			GFile* _tmp9_;
#line 132 "../src/Permissions/Backend/App.vala"
			_tmp9_ = overrides_folder;
#line 132 "../src/Permissions/Backend/App.vala"
			g_file_make_directory (_tmp9_, NULL, &_inner_error0_);
#line 132 "../src/Permissions/Backend/App.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "App.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 131 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 131 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 134 "../src/Permissions/Backend/App.vala"
			_tmp10_ = e;
#line 134 "../src/Permissions/Backend/App.vala"
			_tmp11_ = _tmp10_->message;
#line 134 "../src/Permissions/Backend/App.vala"
			g_critical ("App.vala:134: Couldn't create overrides folder: %s", _tmp11_);
#line 131 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 221 "App.c"
		}
		__finally0:
#line 131 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/Permissions/Backend/App.vala"
			_g_object_unref0 (overrides_folder);
#line 131 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_folder_path);
#line 131 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 131 "../src/Permissions/Backend/App.vala"
			return NULL;
#line 236 "App.c"
		}
	}
#line 138 "../src/Permissions/Backend/App.vala"
	_tmp12_ = overrides_folder_path;
#line 138 "../src/Permissions/Backend/App.vala"
	_tmp13_ = self->priv->_id;
#line 138 "../src/Permissions/Backend/App.vala"
	_tmp14_ = g_build_path (G_DIR_SEPARATOR_S, _tmp12_, _tmp13_, NULL);
#line 138 "../src/Permissions/Backend/App.vala"
	result = _tmp14_;
#line 138 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (overrides_folder);
#line 138 "../src/Permissions/Backend/App.vala"
	_g_free0 (overrides_folder_path);
#line 138 "../src/Permissions/Backend/App.vala"
	return result;
#line 253 "App.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 272 "App.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 294 "App.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 298 "App.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 304 "App.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 308 "App.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 312 "App.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 320 "App.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 348 "App.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 357 "App.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 371 "App.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 380 "App.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 394 "App.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 403 "App.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 412 "App.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5905 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5906 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5906 "glib-2.0.vapi"
	return result;
#line 425 "App.c"
}

static gboolean
permissions_backend_app_is_permission_overridden (PermissionsBackendApp* self,
                                                  GPtrArray* overrides,
                                                  const gchar* permission)
{
	gchar* _tmp0_ = NULL;
	gchar* negated_permission = NULL;
	gchar* _tmp3_;
	gboolean result;
#line 145 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (overrides != NULL, FALSE);
#line 145 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (permission != NULL, FALSE);
#line 146 "../src/Permissions/Backend/App.vala"
	if (string_contains (permission, "=!")) {
#line 445 "App.c"
		gchar* _tmp1_;
#line 147 "../src/Permissions/Backend/App.vala"
		_tmp1_ = string_replace (permission, "=!", "=");
#line 147 "../src/Permissions/Backend/App.vala"
		_g_free0 (_tmp0_);
#line 147 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _tmp1_;
#line 453 "App.c"
	} else {
		gchar* _tmp2_;
#line 148 "../src/Permissions/Backend/App.vala"
		_tmp2_ = string_replace (permission, "=", "=!");
#line 148 "../src/Permissions/Backend/App.vala"
		_g_free0 (_tmp0_);
#line 148 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _tmp2_;
#line 462 "App.c"
	}
#line 146 "../src/Permissions/Backend/App.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 146 "../src/Permissions/Backend/App.vala"
	negated_permission = _tmp3_;
#line 468 "App.c"
	{
		gint i = 0;
#line 150 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 473 "App.c"
		{
			gboolean _tmp4_ = FALSE;
#line 150 "../src/Permissions/Backend/App.vala"
			_tmp4_ = TRUE;
#line 150 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 480 "App.c"
				gint _tmp6_;
				gint _tmp7_;
				gchar* o = NULL;
				gconstpointer _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 150 "../src/Permissions/Backend/App.vala"
				if (!_tmp4_) {
#line 490 "App.c"
					gint _tmp5_;
#line 150 "../src/Permissions/Backend/App.vala"
					_tmp5_ = i;
#line 150 "../src/Permissions/Backend/App.vala"
					i = _tmp5_ + 1;
#line 496 "App.c"
				}
#line 150 "../src/Permissions/Backend/App.vala"
				_tmp4_ = FALSE;
#line 150 "../src/Permissions/Backend/App.vala"
				_tmp6_ = vala_g_ptr_array_get_length (overrides);
#line 150 "../src/Permissions/Backend/App.vala"
				_tmp7_ = _tmp6_;
#line 150 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp7_)) {
#line 150 "../src/Permissions/Backend/App.vala"
					break;
#line 508 "App.c"
				}
#line 151 "../src/Permissions/Backend/App.vala"
				_tmp8_ = g_ptr_array_index (overrides, (guint) i);
#line 151 "../src/Permissions/Backend/App.vala"
				_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 151 "../src/Permissions/Backend/App.vala"
				o = _tmp9_;
#line 152 "../src/Permissions/Backend/App.vala"
				_tmp10_ = o;
#line 152 "../src/Permissions/Backend/App.vala"
				_tmp11_ = negated_permission;
#line 152 "../src/Permissions/Backend/App.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 153 "../src/Permissions/Backend/App.vala"
					result = TRUE;
#line 153 "../src/Permissions/Backend/App.vala"
					_g_free0 (o);
#line 153 "../src/Permissions/Backend/App.vala"
					_g_free0 (negated_permission);
#line 153 "../src/Permissions/Backend/App.vala"
					_g_free0 (_tmp0_);
#line 153 "../src/Permissions/Backend/App.vala"
					return result;
#line 532 "App.c"
				}
#line 150 "../src/Permissions/Backend/App.vala"
				_g_free0 (o);
#line 536 "App.c"
			}
		}
	}
#line 157 "../src/Permissions/Backend/App.vala"
	result = FALSE;
#line 157 "../src/Permissions/Backend/App.vala"
	_g_free0 (negated_permission);
#line 157 "../src/Permissions/Backend/App.vala"
	_g_free0 (_tmp0_);
#line 157 "../src/Permissions/Backend/App.vala"
	return result;
#line 548 "App.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 162 "../src/Permissions/Backend/App.vala"
	return self ? g_object_ref (self) : NULL;
#line 556 "App.c"
}

void
permissions_backend_app_reset_settings_to_standard (PermissionsBackendApp* self)
{
	gchar* overrides_path = NULL;
	gchar* _tmp12_;
	GKeyFile* key_file = NULL;
	GKeyFile* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 160 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 569 "App.c"
	{
		gint i = 0;
#line 161 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 574 "App.c"
		{
			gboolean _tmp0_ = FALSE;
#line 161 "../src/Permissions/Backend/App.vala"
			_tmp0_ = TRUE;
#line 161 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 581 "App.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				PermissionsBackendPermissionSettings* setting = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				PermissionsBackendPermissionSettings* _tmp7_;
				PermissionsBackendPermissionSettings* _tmp8_;
				PermissionsBackendPermissionSettings* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 161 "../src/Permissions/Backend/App.vala"
				if (!_tmp0_) {
#line 595 "App.c"
					gint _tmp1_;
#line 161 "../src/Permissions/Backend/App.vala"
					_tmp1_ = i;
#line 161 "../src/Permissions/Backend/App.vala"
					i = _tmp1_ + 1;
#line 601 "App.c"
				}
#line 161 "../src/Permissions/Backend/App.vala"
				_tmp0_ = FALSE;
#line 161 "../src/Permissions/Backend/App.vala"
				_tmp2_ = self->settings;
#line 161 "../src/Permissions/Backend/App.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 161 "../src/Permissions/Backend/App.vala"
				_tmp4_ = _tmp3_;
#line 161 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp4_)) {
#line 161 "../src/Permissions/Backend/App.vala"
					break;
#line 615 "App.c"
				}
#line 162 "../src/Permissions/Backend/App.vala"
				_tmp5_ = self->settings;
#line 162 "../src/Permissions/Backend/App.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 162 "../src/Permissions/Backend/App.vala"
				_tmp7_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp6_);
#line 162 "../src/Permissions/Backend/App.vala"
				setting = _tmp7_;
#line 163 "../src/Permissions/Backend/App.vala"
				_tmp8_ = setting;
#line 163 "../src/Permissions/Backend/App.vala"
				_tmp9_ = setting;
#line 163 "../src/Permissions/Backend/App.vala"
				_tmp10_ = permissions_backend_permission_settings_get_standard (_tmp9_);
#line 163 "../src/Permissions/Backend/App.vala"
				_tmp11_ = _tmp10_;
#line 163 "../src/Permissions/Backend/App.vala"
				permissions_backend_permission_settings_set_enabled (_tmp8_, _tmp11_);
#line 161 "../src/Permissions/Backend/App.vala"
				_g_object_unref0 (setting);
#line 637 "App.c"
			}
		}
	}
#line 166 "../src/Permissions/Backend/App.vala"
	_tmp12_ = permissions_backend_app_get_overrides_path (self);
#line 166 "../src/Permissions/Backend/App.vala"
	overrides_path = _tmp12_;
#line 168 "../src/Permissions/Backend/App.vala"
	_tmp13_ = g_key_file_new ();
#line 168 "../src/Permissions/Backend/App.vala"
	key_file = _tmp13_;
#line 649 "App.c"
	{
		GKeyFile* _tmp14_;
		const gchar* _tmp15_;
#line 171 "../src/Permissions/Backend/App.vala"
		_tmp14_ = key_file;
#line 171 "../src/Permissions/Backend/App.vala"
		_tmp15_ = overrides_path;
#line 171 "../src/Permissions/Backend/App.vala"
		g_key_file_load_from_file (_tmp14_, _tmp15_, G_KEY_FILE_NONE, &_inner_error0_);
#line 171 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 663 "App.c"
				goto __catch0_g_key_file_error;
			}
#line 171 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 668 "App.c"
				goto __catch0_g_file_error;
			}
#line 171 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 171 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 171 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 171 "../src/Permissions/Backend/App.vala"
			return;
#line 681 "App.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 170 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 170 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 173 "../src/Permissions/Backend/App.vala"
		_tmp16_ = e;
#line 173 "../src/Permissions/Backend/App.vala"
		_tmp17_ = _tmp16_->message;
#line 173 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:173: Couldn't create overrides keyfile: %s", _tmp17_);
#line 170 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 702 "App.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 170 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 170 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 175 "../src/Permissions/Backend/App.vala"
		_tmp18_ = e;
#line 175 "../src/Permissions/Backend/App.vala"
		_tmp19_ = _tmp18_->message;
#line 175 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:175: Couldn't load overrides file: %s", _tmp19_);
#line 170 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 722 "App.c"
	}
	__finally0:
#line 170 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 170 "../src/Permissions/Backend/App.vala"
		_g_free0 (overrides_path);
#line 170 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 170 "../src/Permissions/Backend/App.vala"
		return;
#line 737 "App.c"
	}
	{
		GKeyFile* _tmp43_;
		const gchar* _tmp44_;
		{
			gint i = 0;
#line 179 "../src/Permissions/Backend/App.vala"
			i = 0;
#line 746 "App.c"
			{
				gboolean _tmp20_ = FALSE;
#line 179 "../src/Permissions/Backend/App.vala"
				_tmp20_ = TRUE;
#line 179 "../src/Permissions/Backend/App.vala"
				while (TRUE) {
#line 753 "App.c"
					GPtrArray* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					PermissionsBackendPermissionSettings* setting = NULL;
					GPtrArray* _tmp25_;
					gconstpointer _tmp26_;
					PermissionsBackendPermissionSettings* _tmp27_;
					gchar** key_value_pair = NULL;
					PermissionsBackendPermissionSettings* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					gchar** _tmp31_;
					gchar** _tmp32_;
					gint key_value_pair_length1;
					gint _key_value_pair_size_;
					gchar* key = NULL;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gboolean _tmp36_ = FALSE;
					GKeyFile* _tmp37_;
#line 179 "../src/Permissions/Backend/App.vala"
					if (!_tmp20_) {
#line 778 "App.c"
						gint _tmp21_;
#line 179 "../src/Permissions/Backend/App.vala"
						_tmp21_ = i;
#line 179 "../src/Permissions/Backend/App.vala"
						i = _tmp21_ + 1;
#line 784 "App.c"
					}
#line 179 "../src/Permissions/Backend/App.vala"
					_tmp20_ = FALSE;
#line 179 "../src/Permissions/Backend/App.vala"
					_tmp22_ = self->settings;
#line 179 "../src/Permissions/Backend/App.vala"
					_tmp23_ = vala_g_ptr_array_get_length (_tmp22_);
#line 179 "../src/Permissions/Backend/App.vala"
					_tmp24_ = _tmp23_;
#line 179 "../src/Permissions/Backend/App.vala"
					if (!(i < _tmp24_)) {
#line 179 "../src/Permissions/Backend/App.vala"
						break;
#line 798 "App.c"
					}
#line 180 "../src/Permissions/Backend/App.vala"
					_tmp25_ = self->settings;
#line 180 "../src/Permissions/Backend/App.vala"
					_tmp26_ = g_ptr_array_index (_tmp25_, (guint) i);
#line 180 "../src/Permissions/Backend/App.vala"
					_tmp27_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp26_);
#line 180 "../src/Permissions/Backend/App.vala"
					setting = _tmp27_;
#line 182 "../src/Permissions/Backend/App.vala"
					_tmp28_ = setting;
#line 182 "../src/Permissions/Backend/App.vala"
					_tmp29_ = permissions_backend_permission_settings_get_context (_tmp28_);
#line 182 "../src/Permissions/Backend/App.vala"
					_tmp30_ = _tmp29_;
#line 182 "../src/Permissions/Backend/App.vala"
					_tmp32_ = _tmp31_ = g_strsplit (_tmp30_, "=", 0);
#line 182 "../src/Permissions/Backend/App.vala"
					key_value_pair = _tmp32_;
#line 182 "../src/Permissions/Backend/App.vala"
					key_value_pair_length1 = _vala_array_length (_tmp31_);
#line 182 "../src/Permissions/Backend/App.vala"
					_key_value_pair_size_ = key_value_pair_length1;
#line 183 "../src/Permissions/Backend/App.vala"
					_tmp33_ = key_value_pair;
#line 183 "../src/Permissions/Backend/App.vala"
					_tmp33__length1 = key_value_pair_length1;
#line 183 "../src/Permissions/Backend/App.vala"
					_tmp34_ = _tmp33_[0];
#line 183 "../src/Permissions/Backend/App.vala"
					_tmp35_ = g_strdup (_tmp34_);
#line 183 "../src/Permissions/Backend/App.vala"
					key = _tmp35_;
#line 185 "../src/Permissions/Backend/App.vala"
					_tmp37_ = key_file;
#line 185 "../src/Permissions/Backend/App.vala"
					if (g_key_file_has_group (_tmp37_, PERMISSIONS_BACKEND_APP_GROUP)) {
#line 836 "App.c"
						gboolean _tmp38_ = FALSE;
						GKeyFile* _tmp39_;
						const gchar* _tmp40_;
#line 185 "../src/Permissions/Backend/App.vala"
						_tmp39_ = key_file;
#line 185 "../src/Permissions/Backend/App.vala"
						_tmp40_ = key;
#line 185 "../src/Permissions/Backend/App.vala"
						_tmp38_ = g_key_file_has_key (_tmp39_, PERMISSIONS_BACKEND_APP_GROUP, _tmp40_, &_inner_error0_);
#line 185 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 185 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 185 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 185 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 856 "App.c"
								goto __catch1_g_key_file_error;
							}
#line 185 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 861 "App.c"
								goto __catch1_g_file_error;
							}
#line 185 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 185 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 185 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 185 "../src/Permissions/Backend/App.vala"
							return;
#line 874 "App.c"
						}
#line 185 "../src/Permissions/Backend/App.vala"
						_tmp36_ = _tmp38_;
#line 878 "App.c"
					} else {
#line 185 "../src/Permissions/Backend/App.vala"
						_tmp36_ = FALSE;
#line 882 "App.c"
					}
#line 185 "../src/Permissions/Backend/App.vala"
					if (_tmp36_) {
#line 886 "App.c"
						GKeyFile* _tmp41_;
						const gchar* _tmp42_;
#line 186 "../src/Permissions/Backend/App.vala"
						_tmp41_ = key_file;
#line 186 "../src/Permissions/Backend/App.vala"
						_tmp42_ = key;
#line 186 "../src/Permissions/Backend/App.vala"
						g_key_file_remove_key (_tmp41_, PERMISSIONS_BACKEND_APP_GROUP, _tmp42_, &_inner_error0_);
#line 186 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 186 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 186 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 186 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 186 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 905 "App.c"
								goto __catch1_g_key_file_error;
							}
#line 186 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 910 "App.c"
								goto __catch1_g_file_error;
							}
#line 186 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 186 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 186 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 186 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 186 "../src/Permissions/Backend/App.vala"
							return;
#line 923 "App.c"
						}
					}
#line 179 "../src/Permissions/Backend/App.vala"
					_g_free0 (key);
#line 179 "../src/Permissions/Backend/App.vala"
					key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 179 "../src/Permissions/Backend/App.vala"
					_g_object_unref0 (setting);
#line 932 "App.c"
				}
			}
		}
#line 190 "../src/Permissions/Backend/App.vala"
		_tmp43_ = key_file;
#line 190 "../src/Permissions/Backend/App.vala"
		_tmp44_ = overrides_path;
#line 190 "../src/Permissions/Backend/App.vala"
		g_key_file_save_to_file (_tmp43_, _tmp44_, &_inner_error0_);
#line 190 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 946 "App.c"
				goto __catch1_g_key_file_error;
			}
#line 190 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 951 "App.c"
				goto __catch1_g_file_error;
			}
#line 190 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 190 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 190 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 190 "../src/Permissions/Backend/App.vala"
			return;
#line 964 "App.c"
		}
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp45_;
		const gchar* _tmp46_;
#line 178 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 178 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 192 "../src/Permissions/Backend/App.vala"
		_tmp45_ = e;
#line 192 "../src/Permissions/Backend/App.vala"
		_tmp46_ = _tmp45_->message;
#line 192 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:192: Couldn't remove key from overrides keyfile: %s", _tmp46_);
#line 178 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 985 "App.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
#line 178 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 178 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 194 "../src/Permissions/Backend/App.vala"
		_tmp47_ = e;
#line 194 "../src/Permissions/Backend/App.vala"
		_tmp48_ = _tmp47_->message;
#line 194 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:194: %s", _tmp48_);
#line 178 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 1005 "App.c"
	}
	__finally1:
#line 178 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 178 "../src/Permissions/Backend/App.vala"
		_g_free0 (overrides_path);
#line 178 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 178 "../src/Permissions/Backend/App.vala"
		return;
#line 1020 "App.c"
	}
#line 160 "../src/Permissions/Backend/App.vala"
	_g_key_file_unref0 (key_file);
#line 160 "../src/Permissions/Backend/App.vala"
	_g_free0 (overrides_path);
#line 1026 "App.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 1040 "App.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1044 "App.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1050 "App.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1055 "App.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1061 "App.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1065 "App.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1069 "App.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1073 "App.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1077 "App.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1081 "App.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1096 "App.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 1105 "App.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1112 "App.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1118 "App.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1126 "App.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1130 "App.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1136 "App.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1141 "App.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1147 "App.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1151 "App.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1155 "App.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 1161 "App.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1167 "App.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1179 "App.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1183 "App.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1187 "App.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 1192 "App.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 1200 "App.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1218 "App.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1224 "App.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1228 "App.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1236 "App.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1245 "App.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1254 "App.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1260 "App.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1268 "App.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1280 "App.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1286 "App.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1290 "App.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1298 "App.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1309 "App.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1318 "App.c"
	}
}

void
permissions_backend_app_save_overrides (PermissionsBackendApp* self)
{
	GError* _inner_error0_ = NULL;
#line 198 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 1328 "App.c"
	{
		gchar* overrides_path = NULL;
		gchar* _tmp0_;
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp1_;
		GKeyFile* _tmp97_;
		const gchar* _tmp98_;
#line 200 "../src/Permissions/Backend/App.vala"
		_tmp0_ = permissions_backend_app_get_overrides_path (self);
#line 200 "../src/Permissions/Backend/App.vala"
		overrides_path = _tmp0_;
#line 202 "../src/Permissions/Backend/App.vala"
		_tmp1_ = g_key_file_new ();
#line 202 "../src/Permissions/Backend/App.vala"
		key_file = _tmp1_;
#line 1344 "App.c"
		{
			GKeyFile* _tmp2_;
			const gchar* _tmp3_;
#line 205 "../src/Permissions/Backend/App.vala"
			_tmp2_ = key_file;
#line 205 "../src/Permissions/Backend/App.vala"
			_tmp3_ = overrides_path;
#line 205 "../src/Permissions/Backend/App.vala"
			g_key_file_load_from_file (_tmp2_, _tmp3_, G_KEY_FILE_NONE, &_inner_error0_);
#line 205 "../src/Permissions/Backend/App.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1358 "App.c"
					goto __catch1_g_key_file_error;
				}
#line 205 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1363 "App.c"
					goto __catch1_g_file_error;
				}
#line 205 "../src/Permissions/Backend/App.vala"
				_g_key_file_unref0 (key_file);
#line 205 "../src/Permissions/Backend/App.vala"
				_g_free0 (overrides_path);
#line 205 "../src/Permissions/Backend/App.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 205 "../src/Permissions/Backend/App.vala"
				g_clear_error (&_inner_error0_);
#line 205 "../src/Permissions/Backend/App.vala"
				return;
#line 1376 "App.c"
			}
		}
		goto __finally1;
		__catch1_g_key_file_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 204 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 204 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 207 "../src/Permissions/Backend/App.vala"
			_tmp4_ = e;
#line 207 "../src/Permissions/Backend/App.vala"
			_tmp5_ = _tmp4_->message;
#line 207 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:207: Couldn't create overrides keyfile: %s", _tmp5_);
#line 204 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 1397 "App.c"
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 204 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 204 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 209 "../src/Permissions/Backend/App.vala"
			_tmp6_ = e;
#line 209 "../src/Permissions/Backend/App.vala"
			_tmp7_ = _tmp6_->message;
#line 209 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:209: Couldn't load overrides file: %s", _tmp7_);
#line 204 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 1417 "App.c"
		}
		__finally1:
#line 204 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 204 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 204 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1428 "App.c"
				goto __catch0_g_key_file_error;
			}
#line 204 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1433 "App.c"
				goto __catch0_g_file_error;
			}
#line 204 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 204 "../src/Permissions/Backend/App.vala"
			return;
#line 1442 "App.c"
		}
		{
			gint i = 0;
#line 212 "../src/Permissions/Backend/App.vala"
			i = 0;
#line 1448 "App.c"
			{
				gboolean _tmp8_ = FALSE;
#line 212 "../src/Permissions/Backend/App.vala"
				_tmp8_ = TRUE;
#line 212 "../src/Permissions/Backend/App.vala"
				while (TRUE) {
#line 1455 "App.c"
					GPtrArray* _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
					PermissionsBackendPermissionSettings* setting = NULL;
					GPtrArray* _tmp13_;
					gconstpointer _tmp14_;
					PermissionsBackendPermissionSettings* _tmp15_;
					gchar** key_value_pair = NULL;
					PermissionsBackendPermissionSettings* _tmp16_;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar** _tmp19_;
					gchar** _tmp20_;
					gint key_value_pair_length1;
					gint _key_value_pair_size_;
					gchar* key = NULL;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* value = NULL;
					gchar** _tmp24_;
					gint _tmp24__length1;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gboolean _tmp27_ = FALSE;
					GKeyFile* _tmp28_;
#line 212 "../src/Permissions/Backend/App.vala"
					if (!_tmp8_) {
#line 1485 "App.c"
						gint _tmp9_;
#line 212 "../src/Permissions/Backend/App.vala"
						_tmp9_ = i;
#line 212 "../src/Permissions/Backend/App.vala"
						i = _tmp9_ + 1;
#line 1491 "App.c"
					}
#line 212 "../src/Permissions/Backend/App.vala"
					_tmp8_ = FALSE;
#line 212 "../src/Permissions/Backend/App.vala"
					_tmp10_ = self->settings;
#line 212 "../src/Permissions/Backend/App.vala"
					_tmp11_ = vala_g_ptr_array_get_length (_tmp10_);
#line 212 "../src/Permissions/Backend/App.vala"
					_tmp12_ = _tmp11_;
#line 212 "../src/Permissions/Backend/App.vala"
					if (!(i < _tmp12_)) {
#line 212 "../src/Permissions/Backend/App.vala"
						break;
#line 1505 "App.c"
					}
#line 213 "../src/Permissions/Backend/App.vala"
					_tmp13_ = self->settings;
#line 213 "../src/Permissions/Backend/App.vala"
					_tmp14_ = g_ptr_array_index (_tmp13_, (guint) i);
#line 213 "../src/Permissions/Backend/App.vala"
					_tmp15_ = _g_object_ref0 ((PermissionsBackendPermissionSettings*) _tmp14_);
#line 213 "../src/Permissions/Backend/App.vala"
					setting = _tmp15_;
#line 215 "../src/Permissions/Backend/App.vala"
					_tmp16_ = setting;
#line 215 "../src/Permissions/Backend/App.vala"
					_tmp17_ = permissions_backend_permission_settings_get_context (_tmp16_);
#line 215 "../src/Permissions/Backend/App.vala"
					_tmp18_ = _tmp17_;
#line 215 "../src/Permissions/Backend/App.vala"
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "=", 0);
#line 215 "../src/Permissions/Backend/App.vala"
					key_value_pair = _tmp20_;
#line 215 "../src/Permissions/Backend/App.vala"
					key_value_pair_length1 = _vala_array_length (_tmp19_);
#line 215 "../src/Permissions/Backend/App.vala"
					_key_value_pair_size_ = key_value_pair_length1;
#line 216 "../src/Permissions/Backend/App.vala"
					_tmp21_ = key_value_pair;
#line 216 "../src/Permissions/Backend/App.vala"
					_tmp21__length1 = key_value_pair_length1;
#line 216 "../src/Permissions/Backend/App.vala"
					_tmp22_ = _tmp21_[0];
#line 216 "../src/Permissions/Backend/App.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 216 "../src/Permissions/Backend/App.vala"
					key = _tmp23_;
#line 218 "../src/Permissions/Backend/App.vala"
					_tmp24_ = key_value_pair;
#line 218 "../src/Permissions/Backend/App.vala"
					_tmp24__length1 = key_value_pair_length1;
#line 218 "../src/Permissions/Backend/App.vala"
					_tmp25_ = _tmp24_[1];
#line 218 "../src/Permissions/Backend/App.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 218 "../src/Permissions/Backend/App.vala"
					value = _tmp26_;
#line 220 "../src/Permissions/Backend/App.vala"
					_tmp28_ = key_file;
#line 220 "../src/Permissions/Backend/App.vala"
					if (g_key_file_has_group (_tmp28_, PERMISSIONS_BACKEND_APP_GROUP)) {
#line 1553 "App.c"
						gboolean _tmp29_ = FALSE;
						GKeyFile* _tmp30_;
						const gchar* _tmp31_;
#line 220 "../src/Permissions/Backend/App.vala"
						_tmp30_ = key_file;
#line 220 "../src/Permissions/Backend/App.vala"
						_tmp31_ = key;
#line 220 "../src/Permissions/Backend/App.vala"
						_tmp29_ = g_key_file_has_key (_tmp30_, PERMISSIONS_BACKEND_APP_GROUP, _tmp31_, &_inner_error0_);
#line 220 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/Permissions/Backend/App.vala"
							_g_free0 (value);
#line 220 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 220 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 220 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 220 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 220 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 220 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1579 "App.c"
								goto __catch0_g_key_file_error;
							}
#line 220 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1584 "App.c"
								goto __catch0_g_file_error;
							}
#line 220 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 220 "../src/Permissions/Backend/App.vala"
							return;
#line 1593 "App.c"
						}
#line 220 "../src/Permissions/Backend/App.vala"
						_tmp27_ = _tmp29_;
#line 1597 "App.c"
					} else {
#line 220 "../src/Permissions/Backend/App.vala"
						_tmp27_ = FALSE;
#line 1601 "App.c"
					}
#line 220 "../src/Permissions/Backend/App.vala"
					if (_tmp27_) {
#line 1605 "App.c"
						{
							gchar* existing_value = NULL;
							GKeyFile* _tmp32_;
							const gchar* _tmp33_;
							gchar* _tmp34_;
							gchar** existing_values = NULL;
							const gchar* _tmp35_;
							gchar** _tmp36_;
							gchar** _tmp37_;
							gint existing_values_length1;
							gint _existing_values_size_;
							GeeHashSet* values_list = NULL;
							GeeHashSet* _tmp38_;
							gchar** _tmp39_;
							gint _tmp39__length1;
							gboolean _tmp46_ = FALSE;
							GeeHashSet* _tmp47_;
							const gchar* _tmp48_;
							gchar** new_values = NULL;
							GeeHashSet* _tmp68_;
							gint _tmp69_ = 0;
							gpointer* _tmp70_;
							gint new_values_length1;
							gint _new_values_size_;
							gchar* new_value = NULL;
							gchar** _tmp71_;
							gint _tmp71__length1;
							gchar* _tmp72_;
							const gchar* _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
#line 222 "../src/Permissions/Backend/App.vala"
							_tmp32_ = key_file;
#line 222 "../src/Permissions/Backend/App.vala"
							_tmp33_ = key;
#line 222 "../src/Permissions/Backend/App.vala"
							_tmp34_ = g_key_file_get_value (_tmp32_, PERMISSIONS_BACKEND_APP_GROUP, _tmp33_, &_inner_error0_);
#line 222 "../src/Permissions/Backend/App.vala"
							existing_value = _tmp34_;
#line 222 "../src/Permissions/Backend/App.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/Permissions/Backend/App.vala"
								if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1649 "App.c"
									goto __catch2_g_key_file_error;
								}
#line 222 "../src/Permissions/Backend/App.vala"
								_g_free0 (value);
#line 222 "../src/Permissions/Backend/App.vala"
								_g_free0 (key);
#line 222 "../src/Permissions/Backend/App.vala"
								key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 222 "../src/Permissions/Backend/App.vala"
								_g_object_unref0 (setting);
#line 222 "../src/Permissions/Backend/App.vala"
								_g_key_file_unref0 (key_file);
#line 222 "../src/Permissions/Backend/App.vala"
								_g_free0 (overrides_path);
#line 222 "../src/Permissions/Backend/App.vala"
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/Permissions/Backend/App.vala"
								g_clear_error (&_inner_error0_);
#line 222 "../src/Permissions/Backend/App.vala"
								return;
#line 1670 "App.c"
							}
#line 224 "../src/Permissions/Backend/App.vala"
							_tmp35_ = existing_value;
#line 224 "../src/Permissions/Backend/App.vala"
							_tmp37_ = _tmp36_ = g_strsplit (_tmp35_, ";", 0);
#line 224 "../src/Permissions/Backend/App.vala"
							existing_values = _tmp37_;
#line 224 "../src/Permissions/Backend/App.vala"
							existing_values_length1 = _vala_array_length (_tmp36_);
#line 224 "../src/Permissions/Backend/App.vala"
							_existing_values_size_ = existing_values_length1;
#line 225 "../src/Permissions/Backend/App.vala"
							_tmp38_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 225 "../src/Permissions/Backend/App.vala"
							values_list = _tmp38_;
#line 227 "../src/Permissions/Backend/App.vala"
							_tmp39_ = existing_values;
#line 227 "../src/Permissions/Backend/App.vala"
							_tmp39__length1 = existing_values_length1;
#line 1690 "App.c"
							{
								gchar** existing_value_entry_collection = NULL;
								gint existing_value_entry_collection_length1 = 0;
								gint _existing_value_entry_collection_size_ = 0;
								gint existing_value_entry_it = 0;
#line 227 "../src/Permissions/Backend/App.vala"
								existing_value_entry_collection = _tmp39_;
#line 227 "../src/Permissions/Backend/App.vala"
								existing_value_entry_collection_length1 = _tmp39__length1;
#line 227 "../src/Permissions/Backend/App.vala"
								for (existing_value_entry_it = 0; existing_value_entry_it < existing_value_entry_collection_length1; existing_value_entry_it = existing_value_entry_it + 1) {
#line 1702 "App.c"
									gchar* _tmp40_;
									gchar* existing_value_entry = NULL;
#line 227 "../src/Permissions/Backend/App.vala"
									_tmp40_ = g_strdup (existing_value_entry_collection[existing_value_entry_it]);
#line 227 "../src/Permissions/Backend/App.vala"
									existing_value_entry = _tmp40_;
#line 1709 "App.c"
									{
										const gchar* _tmp41_;
										gint _tmp42_;
										gint _tmp43_;
#line 228 "../src/Permissions/Backend/App.vala"
										_tmp41_ = existing_value_entry;
#line 228 "../src/Permissions/Backend/App.vala"
										_tmp42_ = strlen (_tmp41_);
#line 228 "../src/Permissions/Backend/App.vala"
										_tmp43_ = _tmp42_;
#line 228 "../src/Permissions/Backend/App.vala"
										if (_tmp43_ > 0) {
#line 1722 "App.c"
											GeeHashSet* _tmp44_;
											const gchar* _tmp45_;
#line 229 "../src/Permissions/Backend/App.vala"
											_tmp44_ = values_list;
#line 229 "../src/Permissions/Backend/App.vala"
											_tmp45_ = existing_value_entry;
#line 229 "../src/Permissions/Backend/App.vala"
											gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, _tmp45_);
#line 1731 "App.c"
										}
#line 227 "../src/Permissions/Backend/App.vala"
										_g_free0 (existing_value_entry);
#line 1735 "App.c"
									}
								}
							}
#line 233 "../src/Permissions/Backend/App.vala"
							_tmp47_ = values_list;
#line 233 "../src/Permissions/Backend/App.vala"
							_tmp48_ = value;
#line 233 "../src/Permissions/Backend/App.vala"
							if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp47_, _tmp48_)) {
#line 1745 "App.c"
								PermissionsBackendPermissionSettings* _tmp49_;
								gboolean _tmp50_;
								gboolean _tmp51_;
								PermissionsBackendPermissionSettings* _tmp52_;
								gboolean _tmp53_;
								gboolean _tmp54_;
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp49_ = setting;
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp50_ = permissions_backend_permission_settings_get_enabled (_tmp49_);
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp51_ = _tmp50_;
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp52_ = setting;
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp53_ = permissions_backend_permission_settings_get_standard (_tmp52_);
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp54_ = _tmp53_;
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp46_ = _tmp51_ == _tmp54_;
#line 1766 "App.c"
							} else {
#line 233 "../src/Permissions/Backend/App.vala"
								_tmp46_ = FALSE;
#line 1770 "App.c"
							}
#line 233 "../src/Permissions/Backend/App.vala"
							if (_tmp46_) {
#line 1774 "App.c"
								GeeHashSet* _tmp55_;
								const gchar* _tmp56_;
#line 234 "../src/Permissions/Backend/App.vala"
								_tmp55_ = values_list;
#line 234 "../src/Permissions/Backend/App.vala"
								_tmp56_ = value;
#line 234 "../src/Permissions/Backend/App.vala"
								gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp55_, _tmp56_);
#line 1783 "App.c"
							} else {
								gboolean _tmp57_ = FALSE;
								GeeHashSet* _tmp58_;
								const gchar* _tmp59_;
#line 235 "../src/Permissions/Backend/App.vala"
								_tmp58_ = values_list;
#line 235 "../src/Permissions/Backend/App.vala"
								_tmp59_ = value;
#line 235 "../src/Permissions/Backend/App.vala"
								if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp58_, _tmp59_)) {
#line 1794 "App.c"
									PermissionsBackendPermissionSettings* _tmp60_;
									gboolean _tmp61_;
									gboolean _tmp62_;
									PermissionsBackendPermissionSettings* _tmp63_;
									gboolean _tmp64_;
									gboolean _tmp65_;
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp60_ = setting;
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp61_ = permissions_backend_permission_settings_get_enabled (_tmp60_);
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp62_ = _tmp61_;
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp63_ = setting;
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp64_ = permissions_backend_permission_settings_get_standard (_tmp63_);
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp65_ = _tmp64_;
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp57_ = _tmp62_ != _tmp65_;
#line 1815 "App.c"
								} else {
#line 235 "../src/Permissions/Backend/App.vala"
									_tmp57_ = FALSE;
#line 1819 "App.c"
								}
#line 235 "../src/Permissions/Backend/App.vala"
								if (_tmp57_) {
#line 1823 "App.c"
									GeeHashSet* _tmp66_;
									const gchar* _tmp67_;
#line 236 "../src/Permissions/Backend/App.vala"
									_tmp66_ = values_list;
#line 236 "../src/Permissions/Backend/App.vala"
									_tmp67_ = value;
#line 236 "../src/Permissions/Backend/App.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp66_, _tmp67_);
#line 1832 "App.c"
								}
							}
#line 239 "../src/Permissions/Backend/App.vala"
							_tmp68_ = values_list;
#line 239 "../src/Permissions/Backend/App.vala"
							_tmp70_ = gee_collection_to_array ((GeeCollection*) _tmp68_, &_tmp69_);
#line 239 "../src/Permissions/Backend/App.vala"
							new_values = _tmp70_;
#line 239 "../src/Permissions/Backend/App.vala"
							new_values_length1 = _tmp69_;
#line 239 "../src/Permissions/Backend/App.vala"
							_new_values_size_ = new_values_length1;
#line 240 "../src/Permissions/Backend/App.vala"
							_tmp71_ = new_values;
#line 240 "../src/Permissions/Backend/App.vala"
							_tmp71__length1 = new_values_length1;
#line 240 "../src/Permissions/Backend/App.vala"
							_tmp72_ = _vala_g_strjoinv (";", _tmp71_, (gint) _tmp71__length1);
#line 240 "../src/Permissions/Backend/App.vala"
							new_value = _tmp72_;
#line 242 "../src/Permissions/Backend/App.vala"
							_tmp73_ = new_value;
#line 242 "../src/Permissions/Backend/App.vala"
							_tmp74_ = strlen (_tmp73_);
#line 242 "../src/Permissions/Backend/App.vala"
							_tmp75_ = _tmp74_;
#line 242 "../src/Permissions/Backend/App.vala"
							if (_tmp75_ > 0) {
#line 1861 "App.c"
								GKeyFile* _tmp76_;
								const gchar* _tmp77_;
								const gchar* _tmp78_;
#line 243 "../src/Permissions/Backend/App.vala"
								_tmp76_ = key_file;
#line 243 "../src/Permissions/Backend/App.vala"
								_tmp77_ = key;
#line 243 "../src/Permissions/Backend/App.vala"
								_tmp78_ = new_value;
#line 243 "../src/Permissions/Backend/App.vala"
								g_key_file_set_value (_tmp76_, PERMISSIONS_BACKEND_APP_GROUP, _tmp77_, _tmp78_);
#line 1873 "App.c"
							} else {
								GKeyFile* _tmp79_;
								const gchar* _tmp80_;
								gchar** _tmp81_ = NULL;
								GKeyFile* _tmp82_;
								gsize _tmp83_ = 0;
								gchar** _tmp84_;
								gint _tmp81__length1;
								gint __tmp81__size_;
#line 245 "../src/Permissions/Backend/App.vala"
								_tmp79_ = key_file;
#line 245 "../src/Permissions/Backend/App.vala"
								_tmp80_ = key;
#line 245 "../src/Permissions/Backend/App.vala"
								g_key_file_remove_key (_tmp79_, PERMISSIONS_BACKEND_APP_GROUP, _tmp80_, &_inner_error0_);
#line 245 "../src/Permissions/Backend/App.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/Permissions/Backend/App.vala"
									_g_free0 (new_value);
#line 245 "../src/Permissions/Backend/App.vala"
									new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (values_list);
#line 245 "../src/Permissions/Backend/App.vala"
									existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/Permissions/Backend/App.vala"
									_g_free0 (existing_value);
#line 245 "../src/Permissions/Backend/App.vala"
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1903 "App.c"
										goto __catch2_g_key_file_error;
									}
#line 245 "../src/Permissions/Backend/App.vala"
									_g_free0 (value);
#line 245 "../src/Permissions/Backend/App.vala"
									_g_free0 (key);
#line 245 "../src/Permissions/Backend/App.vala"
									key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (setting);
#line 245 "../src/Permissions/Backend/App.vala"
									_g_key_file_unref0 (key_file);
#line 245 "../src/Permissions/Backend/App.vala"
									_g_free0 (overrides_path);
#line 245 "../src/Permissions/Backend/App.vala"
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../src/Permissions/Backend/App.vala"
									g_clear_error (&_inner_error0_);
#line 245 "../src/Permissions/Backend/App.vala"
									return;
#line 1924 "App.c"
								}
#line 247 "../src/Permissions/Backend/App.vala"
								_tmp82_ = key_file;
#line 247 "../src/Permissions/Backend/App.vala"
								_tmp84_ = g_key_file_get_keys (_tmp82_, PERMISSIONS_BACKEND_APP_GROUP, &_tmp83_, &_inner_error0_);
#line 247 "../src/Permissions/Backend/App.vala"
								_tmp81_ = _tmp84_;
#line 247 "../src/Permissions/Backend/App.vala"
								_tmp81__length1 = _tmp83_;
#line 247 "../src/Permissions/Backend/App.vala"
								__tmp81__size_ = _tmp81__length1;
#line 247 "../src/Permissions/Backend/App.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../src/Permissions/Backend/App.vala"
									_g_free0 (new_value);
#line 247 "../src/Permissions/Backend/App.vala"
									new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (values_list);
#line 247 "../src/Permissions/Backend/App.vala"
									existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/Permissions/Backend/App.vala"
									_g_free0 (existing_value);
#line 247 "../src/Permissions/Backend/App.vala"
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1950 "App.c"
										goto __catch2_g_key_file_error;
									}
#line 247 "../src/Permissions/Backend/App.vala"
									_g_free0 (value);
#line 247 "../src/Permissions/Backend/App.vala"
									_g_free0 (key);
#line 247 "../src/Permissions/Backend/App.vala"
									key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/Permissions/Backend/App.vala"
									_g_object_unref0 (setting);
#line 247 "../src/Permissions/Backend/App.vala"
									_g_key_file_unref0 (key_file);
#line 247 "../src/Permissions/Backend/App.vala"
									_g_free0 (overrides_path);
#line 247 "../src/Permissions/Backend/App.vala"
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../src/Permissions/Backend/App.vala"
									g_clear_error (&_inner_error0_);
#line 247 "../src/Permissions/Backend/App.vala"
									return;
#line 1971 "App.c"
								}
#line 247 "../src/Permissions/Backend/App.vala"
								if (_tmp81__length1 == 0) {
#line 1975 "App.c"
									GKeyFile* _tmp85_;
#line 248 "../src/Permissions/Backend/App.vala"
									_tmp85_ = key_file;
#line 248 "../src/Permissions/Backend/App.vala"
									g_key_file_remove_group (_tmp85_, PERMISSIONS_BACKEND_APP_GROUP, &_inner_error0_);
#line 248 "../src/Permissions/Backend/App.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/Permissions/Backend/App.vala"
										_tmp81_ = (_vala_array_free (_tmp81_, _tmp81__length1, (GDestroyNotify) g_free), NULL);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_free0 (new_value);
#line 248 "../src/Permissions/Backend/App.vala"
										new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_object_unref0 (values_list);
#line 248 "../src/Permissions/Backend/App.vala"
										existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_free0 (existing_value);
#line 248 "../src/Permissions/Backend/App.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1997 "App.c"
											goto __catch2_g_key_file_error;
										}
#line 248 "../src/Permissions/Backend/App.vala"
										_g_free0 (value);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_free0 (key);
#line 248 "../src/Permissions/Backend/App.vala"
										key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_object_unref0 (setting);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_key_file_unref0 (key_file);
#line 248 "../src/Permissions/Backend/App.vala"
										_g_free0 (overrides_path);
#line 248 "../src/Permissions/Backend/App.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 248 "../src/Permissions/Backend/App.vala"
										g_clear_error (&_inner_error0_);
#line 248 "../src/Permissions/Backend/App.vala"
										return;
#line 2018 "App.c"
									}
								}
#line 242 "../src/Permissions/Backend/App.vala"
								_tmp81_ = (_vala_array_free (_tmp81_, _tmp81__length1, (GDestroyNotify) g_free), NULL);
#line 2023 "App.c"
							}
#line 221 "../src/Permissions/Backend/App.vala"
							_g_free0 (new_value);
#line 221 "../src/Permissions/Backend/App.vala"
							new_values = (_vala_array_free (new_values, new_values_length1, (GDestroyNotify) g_free), NULL);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (values_list);
#line 221 "../src/Permissions/Backend/App.vala"
							existing_values = (_vala_array_free (existing_values, existing_values_length1, (GDestroyNotify) g_free), NULL);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_free0 (existing_value);
#line 2035 "App.c"
						}
						goto __finally2;
						__catch2_g_key_file_error:
						{
							GError* e = NULL;
							GError* _tmp86_;
							const gchar* _tmp87_;
#line 221 "../src/Permissions/Backend/App.vala"
							e = _inner_error0_;
#line 221 "../src/Permissions/Backend/App.vala"
							_inner_error0_ = NULL;
#line 252 "../src/Permissions/Backend/App.vala"
							_tmp86_ = e;
#line 252 "../src/Permissions/Backend/App.vala"
							_tmp87_ = _tmp86_->message;
#line 252 "../src/Permissions/Backend/App.vala"
							g_debug ("App.vala:252: %s", _tmp87_);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_error_free0 (e);
#line 2055 "App.c"
						}
						__finally2:
#line 221 "../src/Permissions/Backend/App.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../src/Permissions/Backend/App.vala"
							_g_free0 (value);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_free0 (key);
#line 221 "../src/Permissions/Backend/App.vala"
							key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_object_unref0 (setting);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_key_file_unref0 (key_file);
#line 221 "../src/Permissions/Backend/App.vala"
							_g_free0 (overrides_path);
#line 221 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2074 "App.c"
								goto __catch0_g_key_file_error;
							}
#line 221 "../src/Permissions/Backend/App.vala"
							if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2079 "App.c"
								goto __catch0_g_file_error;
							}
#line 221 "../src/Permissions/Backend/App.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../src/Permissions/Backend/App.vala"
							g_clear_error (&_inner_error0_);
#line 221 "../src/Permissions/Backend/App.vala"
							return;
#line 2088 "App.c"
						}
					} else {
						PermissionsBackendPermissionSettings* _tmp88_;
						gboolean _tmp89_;
						gboolean _tmp90_;
						PermissionsBackendPermissionSettings* _tmp91_;
						gboolean _tmp92_;
						gboolean _tmp93_;
#line 255 "../src/Permissions/Backend/App.vala"
						_tmp88_ = setting;
#line 255 "../src/Permissions/Backend/App.vala"
						_tmp89_ = permissions_backend_permission_settings_get_enabled (_tmp88_);
#line 255 "../src/Permissions/Backend/App.vala"
						_tmp90_ = _tmp89_;
#line 255 "../src/Permissions/Backend/App.vala"
						_tmp91_ = setting;
#line 255 "../src/Permissions/Backend/App.vala"
						_tmp92_ = permissions_backend_permission_settings_get_standard (_tmp91_);
#line 255 "../src/Permissions/Backend/App.vala"
						_tmp93_ = _tmp92_;
#line 255 "../src/Permissions/Backend/App.vala"
						if (_tmp90_ != _tmp93_) {
#line 2111 "App.c"
							GKeyFile* _tmp94_;
							const gchar* _tmp95_;
							const gchar* _tmp96_;
#line 256 "../src/Permissions/Backend/App.vala"
							_tmp94_ = key_file;
#line 256 "../src/Permissions/Backend/App.vala"
							_tmp95_ = key;
#line 256 "../src/Permissions/Backend/App.vala"
							_tmp96_ = value;
#line 256 "../src/Permissions/Backend/App.vala"
							g_key_file_set_value (_tmp94_, PERMISSIONS_BACKEND_APP_GROUP, _tmp95_, _tmp96_);
#line 2123 "App.c"
						}
					}
#line 212 "../src/Permissions/Backend/App.vala"
					_g_free0 (value);
#line 212 "../src/Permissions/Backend/App.vala"
					_g_free0 (key);
#line 212 "../src/Permissions/Backend/App.vala"
					key_value_pair = (_vala_array_free (key_value_pair, key_value_pair_length1, (GDestroyNotify) g_free), NULL);
#line 212 "../src/Permissions/Backend/App.vala"
					_g_object_unref0 (setting);
#line 2134 "App.c"
				}
			}
		}
#line 261 "../src/Permissions/Backend/App.vala"
		_tmp97_ = key_file;
#line 261 "../src/Permissions/Backend/App.vala"
		_tmp98_ = overrides_path;
#line 261 "../src/Permissions/Backend/App.vala"
		g_key_file_save_to_file (_tmp97_, _tmp98_, &_inner_error0_);
#line 261 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 261 "../src/Permissions/Backend/App.vala"
			_g_free0 (overrides_path);
#line 261 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2152 "App.c"
				goto __catch0_g_key_file_error;
			}
#line 261 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2157 "App.c"
				goto __catch0_g_file_error;
			}
#line 261 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 261 "../src/Permissions/Backend/App.vala"
			return;
#line 2166 "App.c"
		}
#line 199 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 199 "../src/Permissions/Backend/App.vala"
		_g_free0 (overrides_path);
#line 2172 "App.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp99_;
		const gchar* _tmp100_;
#line 199 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 199 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 263 "../src/Permissions/Backend/App.vala"
		_tmp99_ = e;
#line 263 "../src/Permissions/Backend/App.vala"
		_tmp100_ = _tmp99_->message;
#line 263 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:263: Couldn't save overrides keyfile: %s", _tmp100_);
#line 199 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 2192 "App.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp101_;
		const gchar* _tmp102_;
#line 199 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 199 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 265 "../src/Permissions/Backend/App.vala"
		_tmp101_ = e;
#line 265 "../src/Permissions/Backend/App.vala"
		_tmp102_ = _tmp101_->message;
#line 265 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:265: %s", _tmp102_);
#line 199 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 2212 "App.c"
	}
	__finally0:
#line 199 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 199 "../src/Permissions/Backend/App.vala"
		return;
#line 2223 "App.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 270 "../src/Permissions/Backend/App.vala"
	var = (g_free (var), NULL);
#line 2232 "App.c"
}

static GPtrArray*
permissions_backend_app_get_permissions_for_keyfile (PermissionsBackendApp* self,
                                                     GKeyFile* key_file)
{
	GPtrArray* permissions = NULL;
	GPtrArray* _tmp0_;
	GError* _inner_error0_ = NULL;
	GPtrArray* result;
#line 269 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (key_file != NULL, NULL);
#line 270 "../src/Permissions/Backend/App.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 270 "../src/Permissions/Backend/App.vala"
	permissions = _tmp0_;
#line 272 "../src/Permissions/Backend/App.vala"
	if (!g_key_file_has_group (key_file, PERMISSIONS_BACKEND_APP_GROUP)) {
#line 273 "../src/Permissions/Backend/App.vala"
		result = permissions;
#line 273 "../src/Permissions/Backend/App.vala"
		return result;
#line 2257 "App.c"
	}
	{
		gchar** keys = NULL;
		gsize _tmp1_ = 0;
		gchar** _tmp2_;
		gint keys_length1;
		gint _keys_size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 277 "../src/Permissions/Backend/App.vala"
		_tmp2_ = g_key_file_get_keys (key_file, PERMISSIONS_BACKEND_APP_GROUP, &_tmp1_, &_inner_error0_);
#line 277 "../src/Permissions/Backend/App.vala"
		keys = _tmp2_;
#line 277 "../src/Permissions/Backend/App.vala"
		keys_length1 = _tmp1_;
#line 277 "../src/Permissions/Backend/App.vala"
		_keys_size_ = keys_length1;
#line 277 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2277 "App.c"
			goto __catch0_g_error;
		}
#line 279 "../src/Permissions/Backend/App.vala"
		_tmp3_ = keys;
#line 279 "../src/Permissions/Backend/App.vala"
		_tmp3__length1 = keys_length1;
#line 2284 "App.c"
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 279 "../src/Permissions/Backend/App.vala"
			key_collection = _tmp3_;
#line 279 "../src/Permissions/Backend/App.vala"
			key_collection_length1 = _tmp3__length1;
#line 279 "../src/Permissions/Backend/App.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 2296 "App.c"
				const gchar* key = NULL;
#line 279 "../src/Permissions/Backend/App.vala"
				key = key_collection[key_it];
#line 2300 "App.c"
				{
					gchar** values = NULL;
					const gchar* _tmp4_;
					gsize _tmp5_ = 0;
					gchar** _tmp6_;
					gint values_length1;
					gint _values_size_;
					gchar** _tmp7_;
					gint _tmp7__length1;
#line 280 "../src/Permissions/Backend/App.vala"
					_tmp4_ = key;
#line 280 "../src/Permissions/Backend/App.vala"
					_tmp6_ = g_key_file_get_string_list (key_file, PERMISSIONS_BACKEND_APP_GROUP, _tmp4_, &_tmp5_, &_inner_error0_);
#line 280 "../src/Permissions/Backend/App.vala"
					values = _tmp6_;
#line 280 "../src/Permissions/Backend/App.vala"
					values_length1 = _tmp5_;
#line 280 "../src/Permissions/Backend/App.vala"
					_values_size_ = values_length1;
#line 280 "../src/Permissions/Backend/App.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "../src/Permissions/Backend/App.vala"
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 2324 "App.c"
						goto __catch0_g_error;
					}
#line 281 "../src/Permissions/Backend/App.vala"
					_tmp7_ = values;
#line 281 "../src/Permissions/Backend/App.vala"
					_tmp7__length1 = values_length1;
#line 2331 "App.c"
					{
						gchar** value_collection = NULL;
						gint value_collection_length1 = 0;
						gint _value_collection_size_ = 0;
						gint value_it = 0;
#line 281 "../src/Permissions/Backend/App.vala"
						value_collection = _tmp7_;
#line 281 "../src/Permissions/Backend/App.vala"
						value_collection_length1 = _tmp7__length1;
#line 281 "../src/Permissions/Backend/App.vala"
						for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
#line 2343 "App.c"
							const gchar* value = NULL;
#line 281 "../src/Permissions/Backend/App.vala"
							value = value_collection[value_it];
#line 2347 "App.c"
							{
								const gchar* _tmp8_;
								gint _tmp9_;
								gint _tmp10_;
								GPtrArray* _tmp11_;
								const gchar* _tmp12_;
								const gchar* _tmp13_;
								gchar* _tmp14_;
#line 282 "../src/Permissions/Backend/App.vala"
								_tmp8_ = value;
#line 282 "../src/Permissions/Backend/App.vala"
								_tmp9_ = strlen (_tmp8_);
#line 282 "../src/Permissions/Backend/App.vala"
								_tmp10_ = _tmp9_;
#line 282 "../src/Permissions/Backend/App.vala"
								if (_tmp10_ == 0) {
#line 283 "../src/Permissions/Backend/App.vala"
									break;
#line 2366 "App.c"
								}
#line 286 "../src/Permissions/Backend/App.vala"
								_tmp11_ = permissions;
#line 286 "../src/Permissions/Backend/App.vala"
								_tmp12_ = key;
#line 286 "../src/Permissions/Backend/App.vala"
								_tmp13_ = value;
#line 286 "../src/Permissions/Backend/App.vala"
								_tmp14_ = g_strdup_printf ("%s=%s", _tmp12_, _tmp13_);
#line 286 "../src/Permissions/Backend/App.vala"
								g_ptr_array_add (_tmp11_, _tmp14_);
#line 2378 "App.c"
							}
						}
					}
#line 279 "../src/Permissions/Backend/App.vala"
					values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 2384 "App.c"
				}
			}
		}
#line 276 "../src/Permissions/Backend/App.vala"
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 2390 "App.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 276 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 276 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 290 "../src/Permissions/Backend/App.vala"
		_tmp15_ = e;
#line 290 "../src/Permissions/Backend/App.vala"
		_tmp16_ = _tmp15_->message;
#line 290 "../src/Permissions/Backend/App.vala"
		g_critical ("App.vala:290: %s", _tmp16_);
#line 276 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 2410 "App.c"
	}
	__finally0:
#line 276 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (permissions);
#line 276 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 276 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 276 "../src/Permissions/Backend/App.vala"
		return NULL;
#line 2423 "App.c"
	}
#line 293 "../src/Permissions/Backend/App.vala"
	result = permissions;
#line 293 "../src/Permissions/Backend/App.vala"
	return result;
#line 2429 "App.c"
}

FlatpakInstalledRef*
permissions_backend_app_get_installed_ref (PermissionsBackendApp* self)
{
	FlatpakInstalledRef* result;
	FlatpakInstalledRef* _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_installed_ref;
#line 25 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
	return result;
#line 2445 "App.c"
}

static void
permissions_backend_app_set_installed_ref (PermissionsBackendApp* self,
                                           FlatpakInstalledRef* value)
{
	FlatpakInstalledRef* old_value;
#line 25 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_installed_ref (self);
#line 25 "../src/Permissions/Backend/App.vala"
	if (old_value != value) {
#line 2459 "App.c"
		FlatpakInstalledRef* _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (self->priv->_installed_ref);
#line 25 "../src/Permissions/Backend/App.vala"
		self->priv->_installed_ref = _tmp0_;
#line 25 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY]);
#line 2469 "App.c"
	}
}

const gchar*
permissions_backend_app_get_id (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_id;
#line 26 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
	return result;
#line 2486 "App.c"
}

static void
permissions_backend_app_set_id (PermissionsBackendApp* self,
                                const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_id (self);
#line 26 "../src/Permissions/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2500 "App.c"
		gchar* _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Permissions/Backend/App.vala"
		_g_free0 (self->priv->_id);
#line 26 "../src/Permissions/Backend/App.vala"
		self->priv->_id = _tmp0_;
#line 26 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ID_PROPERTY]);
#line 2510 "App.c"
	}
}

const gchar*
permissions_backend_app_get_name (PermissionsBackendApp* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_name;
#line 27 "../src/Permissions/Backend/App.vala"
	result = _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
	return result;
#line 2527 "App.c"
}

static void
permissions_backend_app_set_name (PermissionsBackendApp* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 27 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Permissions/Backend/App.vala"
	old_value = permissions_backend_app_get_name (self);
#line 27 "../src/Permissions/Backend/App.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2541 "App.c"
		gchar* _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Permissions/Backend/App.vala"
		_g_free0 (self->priv->_name);
#line 27 "../src/Permissions/Backend/App.vala"
		self->priv->_name = _tmp0_;
#line 27 "../src/Permissions/Backend/App.vala"
		g_object_notify_by_pspec ((GObject *) self, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NAME_PROPERTY]);
#line 2551 "App.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 36 "../src/Permissions/Backend/App.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 36 "../src/Permissions/Backend/App.vala"
	return _data4_;
#line 2562 "App.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 36 "../src/Permissions/Backend/App.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2572 "App.c"
		PermissionsBackendApp* self;
#line 36 "../src/Permissions/Backend/App.vala"
		self = _data4_->self;
#line 36 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (_data4_->current_permissions);
#line 36 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (_data4_->permissions);
#line 36 "../src/Permissions/Backend/App.vala"
		_g_object_unref0 (self);
#line 36 "../src/Permissions/Backend/App.vala"
		g_slice_free (Block4Data, _data4_);
#line 2584 "App.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 40 "../src/Permissions/Backend/App.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2593 "App.c"
}

static void
_permissions_backend_app___lambda15_ (Block4Data* _data4_,
                                      const gchar* key)
{
	PermissionsBackendApp* self;
	gboolean standard = FALSE;
	gboolean enabled = FALSE;
	PermissionsBackendPermissionSettings* s = NULL;
	PermissionsBackendPermissionSettings* _tmp18_;
	PermissionsBackendPermissionSettings* _tmp19_;
	GPtrArray* _tmp20_;
	PermissionsBackendPermissionSettings* _tmp21_;
	PermissionsBackendPermissionSettings* _tmp22_;
#line 91 "../src/Permissions/Backend/App.vala"
	self = _data4_->self;
#line 91 "../src/Permissions/Backend/App.vala"
	g_return_if_fail (key != NULL);
#line 92 "../src/Permissions/Backend/App.vala"
	standard = FALSE;
#line 93 "../src/Permissions/Backend/App.vala"
	enabled = FALSE;
#line 2617 "App.c"
	{
		gint i = 0;
#line 95 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 2622 "App.c"
		{
			gboolean _tmp0_ = FALSE;
#line 95 "../src/Permissions/Backend/App.vala"
			_tmp0_ = TRUE;
#line 95 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 2629 "App.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gchar* permission = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
#line 95 "../src/Permissions/Backend/App.vala"
				if (!_tmp0_) {
#line 2640 "App.c"
					gint _tmp1_;
#line 95 "../src/Permissions/Backend/App.vala"
					_tmp1_ = i;
#line 95 "../src/Permissions/Backend/App.vala"
					i = _tmp1_ + 1;
#line 2646 "App.c"
				}
#line 95 "../src/Permissions/Backend/App.vala"
				_tmp0_ = FALSE;
#line 95 "../src/Permissions/Backend/App.vala"
				_tmp2_ = _data4_->permissions;
#line 95 "../src/Permissions/Backend/App.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 95 "../src/Permissions/Backend/App.vala"
				_tmp4_ = _tmp3_;
#line 95 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp4_)) {
#line 95 "../src/Permissions/Backend/App.vala"
					break;
#line 2660 "App.c"
				}
#line 96 "../src/Permissions/Backend/App.vala"
				_tmp5_ = _data4_->permissions;
#line 96 "../src/Permissions/Backend/App.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 96 "../src/Permissions/Backend/App.vala"
				_tmp7_ = g_strdup ((const gchar*) _tmp6_);
#line 96 "../src/Permissions/Backend/App.vala"
				permission = _tmp7_;
#line 97 "../src/Permissions/Backend/App.vala"
				_tmp8_ = permission;
#line 97 "../src/Permissions/Backend/App.vala"
				if (g_strcmp0 (key, _tmp8_) == 0) {
#line 98 "../src/Permissions/Backend/App.vala"
					standard = TRUE;
#line 99 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 99 "../src/Permissions/Backend/App.vala"
					break;
#line 2680 "App.c"
				}
#line 95 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 2684 "App.c"
			}
		}
	}
	{
		gint i = 0;
#line 103 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 2692 "App.c"
		{
			gboolean _tmp9_ = FALSE;
#line 103 "../src/Permissions/Backend/App.vala"
			_tmp9_ = TRUE;
#line 103 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 2699 "App.c"
				GPtrArray* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gchar* permission = NULL;
				GPtrArray* _tmp14_;
				gconstpointer _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
#line 103 "../src/Permissions/Backend/App.vala"
				if (!_tmp9_) {
#line 2710 "App.c"
					gint _tmp10_;
#line 103 "../src/Permissions/Backend/App.vala"
					_tmp10_ = i;
#line 103 "../src/Permissions/Backend/App.vala"
					i = _tmp10_ + 1;
#line 2716 "App.c"
				}
#line 103 "../src/Permissions/Backend/App.vala"
				_tmp9_ = FALSE;
#line 103 "../src/Permissions/Backend/App.vala"
				_tmp11_ = _data4_->current_permissions;
#line 103 "../src/Permissions/Backend/App.vala"
				_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
#line 103 "../src/Permissions/Backend/App.vala"
				_tmp13_ = _tmp12_;
#line 103 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp13_)) {
#line 103 "../src/Permissions/Backend/App.vala"
					break;
#line 2730 "App.c"
				}
#line 104 "../src/Permissions/Backend/App.vala"
				_tmp14_ = _data4_->current_permissions;
#line 104 "../src/Permissions/Backend/App.vala"
				_tmp15_ = g_ptr_array_index (_tmp14_, (guint) i);
#line 104 "../src/Permissions/Backend/App.vala"
				_tmp16_ = g_strdup ((const gchar*) _tmp15_);
#line 104 "../src/Permissions/Backend/App.vala"
				permission = _tmp16_;
#line 105 "../src/Permissions/Backend/App.vala"
				_tmp17_ = permission;
#line 105 "../src/Permissions/Backend/App.vala"
				if (g_strcmp0 (key, _tmp17_) == 0) {
#line 106 "../src/Permissions/Backend/App.vala"
					enabled = TRUE;
#line 107 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 107 "../src/Permissions/Backend/App.vala"
					break;
#line 2750 "App.c"
				}
#line 103 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 2754 "App.c"
			}
		}
	}
#line 111 "../src/Permissions/Backend/App.vala"
	_tmp18_ = permissions_backend_permission_settings_new (key, standard);
#line 111 "../src/Permissions/Backend/App.vala"
	s = _tmp18_;
#line 112 "../src/Permissions/Backend/App.vala"
	_tmp19_ = s;
#line 112 "../src/Permissions/Backend/App.vala"
	permissions_backend_permission_settings_set_enabled (_tmp19_, enabled);
#line 114 "../src/Permissions/Backend/App.vala"
	_tmp20_ = self->settings;
#line 114 "../src/Permissions/Backend/App.vala"
	_tmp21_ = s;
#line 114 "../src/Permissions/Backend/App.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 114 "../src/Permissions/Backend/App.vala"
	g_ptr_array_add (_tmp20_, _tmp22_);
#line 91 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (s);
#line 2776 "App.c"
}

static void
__permissions_backend_app___lambda15__gh_func (gconstpointer key,
                                               gconstpointer value,
                                               gpointer self)
{
#line 91 "../src/Permissions/Backend/App.vala"
	_permissions_backend_app___lambda15_ (self, (const gchar*) key);
#line 2786 "App.c"
}

static void
_permissions_backend_app_save_overrides_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 117 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_save_overrides ((PermissionsBackendApp*) self);
#line 2796 "App.c"
}

static GObject *
permissions_backend_app_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PermissionsBackendApp * self;
	Block4Data* _data4_;
	FlatpakInstalledRef* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	FlatpakInstalledRef* _tmp3_;
	const gchar* _tmp4_;
	GPtrArray* _tmp6_;
	GPtrArray* _tmp7_;
	GPtrArray* overrides = NULL;
	GPtrArray* _tmp21_;
	GPtrArray* _tmp32_;
	GHashTable* _tmp58_;
	GHashTable* _tmp59_;
	GError* _inner_error0_ = NULL;
#line 36 "../src/Permissions/Backend/App.vala"
	parent_class = G_OBJECT_CLASS (permissions_backend_app_parent_class);
#line 36 "../src/Permissions/Backend/App.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/Permissions/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 36 "../src/Permissions/Backend/App.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 36 "../src/Permissions/Backend/App.vala"
	_data4_->_ref_count_ = 1;
#line 36 "../src/Permissions/Backend/App.vala"
	_data4_->self = g_object_ref (self);
#line 37 "../src/Permissions/Backend/App.vala"
	_tmp0_ = self->priv->_installed_ref;
#line 37 "../src/Permissions/Backend/App.vala"
	_tmp1_ = flatpak_ref_get_name ((FlatpakRef*) _tmp0_);
#line 37 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_set_id (self, _tmp1_);
#line 38 "../src/Permissions/Backend/App.vala"
	_tmp3_ = self->priv->_installed_ref;
#line 38 "../src/Permissions/Backend/App.vala"
	_tmp4_ = flatpak_installed_ref_get_appdata_name (_tmp3_);
#line 38 "../src/Permissions/Backend/App.vala"
	_tmp2_ = _tmp4_;
#line 38 "../src/Permissions/Backend/App.vala"
	if (_tmp2_ == NULL) {
#line 2847 "App.c"
		const gchar* _tmp5_;
#line 38 "../src/Permissions/Backend/App.vala"
		_tmp5_ = self->priv->_id;
#line 38 "../src/Permissions/Backend/App.vala"
		_tmp2_ = _tmp5_;
#line 2853 "App.c"
	}
#line 38 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_set_name (self, _tmp2_);
#line 40 "../src/Permissions/Backend/App.vala"
	_tmp6_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 40 "../src/Permissions/Backend/App.vala"
	_g_ptr_array_unref0 (self->settings);
#line 40 "../src/Permissions/Backend/App.vala"
	self->settings = _tmp6_;
#line 42 "../src/Permissions/Backend/App.vala"
	_tmp7_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 42 "../src/Permissions/Backend/App.vala"
	_data4_->permissions = _tmp7_;
#line 2867 "App.c"
	{
		GBytes* metadata = NULL;
		FlatpakInstalledRef* _tmp8_;
		GBytes* _tmp9_;
#line 44 "../src/Permissions/Backend/App.vala"
		_tmp8_ = self->priv->_installed_ref;
#line 44 "../src/Permissions/Backend/App.vala"
		_tmp9_ = flatpak_installed_ref_load_metadata (_tmp8_, NULL, &_inner_error0_);
#line 44 "../src/Permissions/Backend/App.vala"
		metadata = _tmp9_;
#line 44 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2880 "App.c"
			goto __catch0_g_error;
		}
		{
			GKeyFile* key_file = NULL;
			GKeyFile* _tmp10_;
			GKeyFile* _tmp11_;
			GBytes* _tmp12_;
			GKeyFile* _tmp13_;
			GPtrArray* _tmp14_;
#line 46 "../src/Permissions/Backend/App.vala"
			_tmp10_ = g_key_file_new ();
#line 46 "../src/Permissions/Backend/App.vala"
			key_file = _tmp10_;
#line 47 "../src/Permissions/Backend/App.vala"
			_tmp11_ = key_file;
#line 47 "../src/Permissions/Backend/App.vala"
			_tmp12_ = metadata;
#line 47 "../src/Permissions/Backend/App.vala"
			g_key_file_load_from_bytes (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
#line 47 "../src/Permissions/Backend/App.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../src/Permissions/Backend/App.vala"
				_g_key_file_unref0 (key_file);
#line 47 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2906 "App.c"
					goto __catch1_g_key_file_error;
				}
#line 47 "../src/Permissions/Backend/App.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2911 "App.c"
					goto __catch1_g_file_error;
				}
#line 47 "../src/Permissions/Backend/App.vala"
				_g_bytes_unref0 (metadata);
#line 47 "../src/Permissions/Backend/App.vala"
				block4_data_unref (_data4_);
#line 47 "../src/Permissions/Backend/App.vala"
				_data4_ = NULL;
#line 47 "../src/Permissions/Backend/App.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "../src/Permissions/Backend/App.vala"
				g_clear_error (&_inner_error0_);
#line 2924 "App.c"
			}
#line 49 "../src/Permissions/Backend/App.vala"
			_tmp13_ = key_file;
#line 49 "../src/Permissions/Backend/App.vala"
			_tmp14_ = permissions_backend_app_get_permissions_for_keyfile (self, _tmp13_);
#line 49 "../src/Permissions/Backend/App.vala"
			_g_ptr_array_unref0 (_data4_->permissions);
#line 49 "../src/Permissions/Backend/App.vala"
			_data4_->permissions = _tmp14_;
#line 45 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 2936 "App.c"
		}
		goto __finally1;
		__catch1_g_key_file_error:
		{
			GError* e = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 45 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 45 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 51 "../src/Permissions/Backend/App.vala"
			_tmp15_ = e;
#line 51 "../src/Permissions/Backend/App.vala"
			_tmp16_ = _tmp15_->message;
#line 51 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:51: Couldn't create permissions keyfile: %s", _tmp16_);
#line 45 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 2956 "App.c"
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp17_;
			const gchar* _tmp18_;
#line 45 "../src/Permissions/Backend/App.vala"
			e = _inner_error0_;
#line 45 "../src/Permissions/Backend/App.vala"
			_inner_error0_ = NULL;
#line 53 "../src/Permissions/Backend/App.vala"
			_tmp17_ = e;
#line 53 "../src/Permissions/Backend/App.vala"
			_tmp18_ = _tmp17_->message;
#line 53 "../src/Permissions/Backend/App.vala"
			g_debug ("App.vala:53: Couldn't load permissions file: %s", _tmp18_);
#line 45 "../src/Permissions/Backend/App.vala"
			_g_error_free0 (e);
#line 2976 "App.c"
		}
		__finally1:
#line 45 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "../src/Permissions/Backend/App.vala"
			_g_bytes_unref0 (metadata);
#line 2983 "App.c"
			goto __catch0_g_error;
		}
#line 43 "../src/Permissions/Backend/App.vala"
		_g_bytes_unref0 (metadata);
#line 2988 "App.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 43 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 43 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 56 "../src/Permissions/Backend/App.vala"
		_tmp19_ = e;
#line 56 "../src/Permissions/Backend/App.vala"
		_tmp20_ = _tmp19_->message;
#line 56 "../src/Permissions/Backend/App.vala"
		g_critical ("App.vala:56: Couldn't load metadata: %s", _tmp20_);
#line 43 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 3008 "App.c"
	}
	__finally0:
#line 43 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/Permissions/Backend/App.vala"
		block4_data_unref (_data4_);
#line 43 "../src/Permissions/Backend/App.vala"
		_data4_ = NULL;
#line 43 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 3021 "App.c"
	}
#line 59 "../src/Permissions/Backend/App.vala"
	_tmp21_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 59 "../src/Permissions/Backend/App.vala"
	overrides = _tmp21_;
#line 3027 "App.c"
	{
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp22_;
		GKeyFile* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GKeyFile* _tmp26_;
		GPtrArray* _tmp27_;
#line 61 "../src/Permissions/Backend/App.vala"
		_tmp22_ = g_key_file_new ();
#line 61 "../src/Permissions/Backend/App.vala"
		key_file = _tmp22_;
#line 62 "../src/Permissions/Backend/App.vala"
		_tmp23_ = key_file;
#line 62 "../src/Permissions/Backend/App.vala"
		_tmp24_ = permissions_backend_app_get_overrides_path (self);
#line 62 "../src/Permissions/Backend/App.vala"
		_tmp25_ = _tmp24_;
#line 62 "../src/Permissions/Backend/App.vala"
		g_key_file_load_from_file (_tmp23_, _tmp25_, G_KEY_FILE_NONE, &_inner_error0_);
#line 62 "../src/Permissions/Backend/App.vala"
		_g_free0 (_tmp25_);
#line 62 "../src/Permissions/Backend/App.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../src/Permissions/Backend/App.vala"
			_g_key_file_unref0 (key_file);
#line 62 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3056 "App.c"
				goto __catch2_g_key_file_error;
			}
#line 62 "../src/Permissions/Backend/App.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3061 "App.c"
				goto __catch2_g_file_error;
			}
#line 62 "../src/Permissions/Backend/App.vala"
			_g_ptr_array_unref0 (overrides);
#line 62 "../src/Permissions/Backend/App.vala"
			block4_data_unref (_data4_);
#line 62 "../src/Permissions/Backend/App.vala"
			_data4_ = NULL;
#line 62 "../src/Permissions/Backend/App.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/Permissions/Backend/App.vala"
			g_clear_error (&_inner_error0_);
#line 3074 "App.c"
		}
#line 64 "../src/Permissions/Backend/App.vala"
		_tmp26_ = key_file;
#line 64 "../src/Permissions/Backend/App.vala"
		_tmp27_ = permissions_backend_app_get_permissions_for_keyfile (self, _tmp26_);
#line 64 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (overrides);
#line 64 "../src/Permissions/Backend/App.vala"
		overrides = _tmp27_;
#line 60 "../src/Permissions/Backend/App.vala"
		_g_key_file_unref0 (key_file);
#line 3086 "App.c"
	}
	goto __finally2;
	__catch2_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 60 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 60 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 66 "../src/Permissions/Backend/App.vala"
		_tmp28_ = e;
#line 66 "../src/Permissions/Backend/App.vala"
		_tmp29_ = _tmp28_->message;
#line 66 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:66: Couldn't create overrides keyfile: %s", _tmp29_);
#line 60 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 3106 "App.c"
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 60 "../src/Permissions/Backend/App.vala"
		e = _inner_error0_;
#line 60 "../src/Permissions/Backend/App.vala"
		_inner_error0_ = NULL;
#line 68 "../src/Permissions/Backend/App.vala"
		_tmp30_ = e;
#line 68 "../src/Permissions/Backend/App.vala"
		_tmp31_ = _tmp30_->message;
#line 68 "../src/Permissions/Backend/App.vala"
		g_debug ("App.vala:68: Couldn't load overrides file: %s", _tmp31_);
#line 60 "../src/Permissions/Backend/App.vala"
		_g_error_free0 (e);
#line 3126 "App.c"
	}
	__finally2:
#line 60 "../src/Permissions/Backend/App.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/Permissions/Backend/App.vala"
		_g_ptr_array_unref0 (overrides);
#line 60 "../src/Permissions/Backend/App.vala"
		block4_data_unref (_data4_);
#line 60 "../src/Permissions/Backend/App.vala"
		_data4_ = NULL;
#line 60 "../src/Permissions/Backend/App.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../src/Permissions/Backend/App.vala"
		g_clear_error (&_inner_error0_);
#line 3141 "App.c"
	}
#line 71 "../src/Permissions/Backend/App.vala"
	_tmp32_ = g_ptr_array_new_full ((guint) 0, _g_free0_);
#line 71 "../src/Permissions/Backend/App.vala"
	_data4_->current_permissions = _tmp32_;
#line 3147 "App.c"
	{
		gint i = 0;
#line 73 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 3152 "App.c"
		{
			gboolean _tmp33_ = FALSE;
#line 73 "../src/Permissions/Backend/App.vala"
			_tmp33_ = TRUE;
#line 73 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 3159 "App.c"
				GPtrArray* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gchar* permission = NULL;
				GPtrArray* _tmp38_;
				gconstpointer _tmp39_;
				gchar* _tmp40_;
				GPtrArray* _tmp41_;
				const gchar* _tmp42_;
				GPtrArray* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp45_;
#line 73 "../src/Permissions/Backend/App.vala"
				if (!_tmp33_) {
#line 3174 "App.c"
					gint _tmp34_;
#line 73 "../src/Permissions/Backend/App.vala"
					_tmp34_ = i;
#line 73 "../src/Permissions/Backend/App.vala"
					i = _tmp34_ + 1;
#line 3180 "App.c"
				}
#line 73 "../src/Permissions/Backend/App.vala"
				_tmp33_ = FALSE;
#line 73 "../src/Permissions/Backend/App.vala"
				_tmp35_ = _data4_->permissions;
#line 73 "../src/Permissions/Backend/App.vala"
				_tmp36_ = vala_g_ptr_array_get_length (_tmp35_);
#line 73 "../src/Permissions/Backend/App.vala"
				_tmp37_ = _tmp36_;
#line 73 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp37_)) {
#line 73 "../src/Permissions/Backend/App.vala"
					break;
#line 3194 "App.c"
				}
#line 74 "../src/Permissions/Backend/App.vala"
				_tmp38_ = _data4_->permissions;
#line 74 "../src/Permissions/Backend/App.vala"
				_tmp39_ = g_ptr_array_index (_tmp38_, (guint) i);
#line 74 "../src/Permissions/Backend/App.vala"
				_tmp40_ = g_strdup ((const gchar*) _tmp39_);
#line 74 "../src/Permissions/Backend/App.vala"
				permission = _tmp40_;
#line 75 "../src/Permissions/Backend/App.vala"
				_tmp41_ = overrides;
#line 75 "../src/Permissions/Backend/App.vala"
				_tmp42_ = permission;
#line 75 "../src/Permissions/Backend/App.vala"
				if (permissions_backend_app_is_permission_overridden (self, _tmp41_, _tmp42_)) {
#line 76 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 76 "../src/Permissions/Backend/App.vala"
					continue;
#line 3214 "App.c"
				}
#line 79 "../src/Permissions/Backend/App.vala"
				_tmp43_ = _data4_->current_permissions;
#line 79 "../src/Permissions/Backend/App.vala"
				_tmp44_ = permission;
#line 79 "../src/Permissions/Backend/App.vala"
				_tmp45_ = g_strdup (_tmp44_);
#line 79 "../src/Permissions/Backend/App.vala"
				g_ptr_array_add (_tmp43_, _tmp45_);
#line 73 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 3226 "App.c"
			}
		}
	}
	{
		gint i = 0;
#line 82 "../src/Permissions/Backend/App.vala"
		i = 0;
#line 3234 "App.c"
		{
			gboolean _tmp46_ = FALSE;
#line 82 "../src/Permissions/Backend/App.vala"
			_tmp46_ = TRUE;
#line 82 "../src/Permissions/Backend/App.vala"
			while (TRUE) {
#line 3241 "App.c"
				GPtrArray* _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
				gchar* permission = NULL;
				GPtrArray* _tmp51_;
				gconstpointer _tmp52_;
				gchar* _tmp53_;
				const gchar* _tmp54_;
				GPtrArray* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
#line 82 "../src/Permissions/Backend/App.vala"
				if (!_tmp46_) {
#line 3255 "App.c"
					gint _tmp47_;
#line 82 "../src/Permissions/Backend/App.vala"
					_tmp47_ = i;
#line 82 "../src/Permissions/Backend/App.vala"
					i = _tmp47_ + 1;
#line 3261 "App.c"
				}
#line 82 "../src/Permissions/Backend/App.vala"
				_tmp46_ = FALSE;
#line 82 "../src/Permissions/Backend/App.vala"
				_tmp48_ = overrides;
#line 82 "../src/Permissions/Backend/App.vala"
				_tmp49_ = vala_g_ptr_array_get_length (_tmp48_);
#line 82 "../src/Permissions/Backend/App.vala"
				_tmp50_ = _tmp49_;
#line 82 "../src/Permissions/Backend/App.vala"
				if (!(i < _tmp50_)) {
#line 82 "../src/Permissions/Backend/App.vala"
					break;
#line 3275 "App.c"
				}
#line 83 "../src/Permissions/Backend/App.vala"
				_tmp51_ = overrides;
#line 83 "../src/Permissions/Backend/App.vala"
				_tmp52_ = g_ptr_array_index (_tmp51_, (guint) i);
#line 83 "../src/Permissions/Backend/App.vala"
				_tmp53_ = g_strdup ((const gchar*) _tmp52_);
#line 83 "../src/Permissions/Backend/App.vala"
				permission = _tmp53_;
#line 84 "../src/Permissions/Backend/App.vala"
				_tmp54_ = permission;
#line 84 "../src/Permissions/Backend/App.vala"
				if (string_contains (_tmp54_, "=!")) {
#line 85 "../src/Permissions/Backend/App.vala"
					_g_free0 (permission);
#line 85 "../src/Permissions/Backend/App.vala"
					continue;
#line 3293 "App.c"
				}
#line 88 "../src/Permissions/Backend/App.vala"
				_tmp55_ = _data4_->current_permissions;
#line 88 "../src/Permissions/Backend/App.vala"
				_tmp56_ = permission;
#line 88 "../src/Permissions/Backend/App.vala"
				_tmp57_ = g_strdup (_tmp56_);
#line 88 "../src/Permissions/Backend/App.vala"
				g_ptr_array_add (_tmp55_, _tmp57_);
#line 82 "../src/Permissions/Backend/App.vala"
				_g_free0 (permission);
#line 3305 "App.c"
			}
		}
	}
#line 91 "../src/Permissions/Backend/App.vala"
	_tmp58_ = permissions_plug_get_permission_names ();
#line 91 "../src/Permissions/Backend/App.vala"
	_tmp59_ = _tmp58_;
#line 91 "../src/Permissions/Backend/App.vala"
	g_hash_table_foreach (_tmp59_, __permissions_backend_app___lambda15__gh_func, _data4_);
#line 117 "../src/Permissions/Backend/App.vala"
	g_signal_connect_object ((GObject*) self, "notify::settings", (GCallback) _permissions_backend_app_save_overrides_g_object_notify, self, 0);
#line 119 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_save_overrides (self);
#line 36 "../src/Permissions/Backend/App.vala"
	_g_ptr_array_unref0 (overrides);
#line 36 "../src/Permissions/Backend/App.vala"
	block4_data_unref (_data4_);
#line 36 "../src/Permissions/Backend/App.vala"
	_data4_ = NULL;
#line 36 "../src/Permissions/Backend/App.vala"
	return obj;
#line 3327 "App.c"
}

static void
permissions_backend_app_class_init (PermissionsBackendAppClass * klass,
                                    gpointer klass_data)
{
#line 24 "../src/Permissions/Backend/App.vala"
	permissions_backend_app_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Permissions/Backend/App.vala"
	g_type_class_adjust_private_offset (klass, &PermissionsBackendApp_private_offset);
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_permissions_backend_app_get_property;
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_permissions_backend_app_set_property;
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->constructor = permissions_backend_app_constructor;
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (klass)->finalize = permissions_backend_app_finalize;
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY] = g_param_spec_object ("installed-ref", "installed-ref", "installed-ref", flatpak_installed_ref_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_ID_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Permissions/Backend/App.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSIONS_BACKEND_APP_NAME_PROPERTY, permissions_backend_app_properties[PERMISSIONS_BACKEND_APP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3352 "App.c"
}

static void
permissions_backend_app_instance_init (PermissionsBackendApp * self,
                                       gpointer klass)
{
#line 24 "../src/Permissions/Backend/App.vala"
	self->priv = permissions_backend_app_get_instance_private (self);
#line 3361 "App.c"
}

static void
permissions_backend_app_finalize (GObject * obj)
{
	PermissionsBackendApp * self;
#line 24 "../src/Permissions/Backend/App.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 25 "../src/Permissions/Backend/App.vala"
	_g_object_unref0 (self->priv->_installed_ref);
#line 26 "../src/Permissions/Backend/App.vala"
	_g_free0 (self->priv->_id);
#line 27 "../src/Permissions/Backend/App.vala"
	_g_free0 (self->priv->_name);
#line 28 "../src/Permissions/Backend/App.vala"
	_g_ptr_array_unref0 (self->settings);
#line 24 "../src/Permissions/Backend/App.vala"
	G_OBJECT_CLASS (permissions_backend_app_parent_class)->finalize (obj);
#line 3380 "App.c"
}

static GType
permissions_backend_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PermissionsBackendAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) permissions_backend_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PermissionsBackendApp), 0, (GInstanceInitFunc) permissions_backend_app_instance_init, NULL };
	GType permissions_backend_app_type_id;
	permissions_backend_app_type_id = g_type_register_static (G_TYPE_OBJECT, "PermissionsBackendApp", &g_define_type_info, 0);
	PermissionsBackendApp_private_offset = g_type_add_instance_private (permissions_backend_app_type_id, sizeof (PermissionsBackendAppPrivate));
	return permissions_backend_app_type_id;
}

GType
permissions_backend_app_get_type (void)
{
	static volatile gsize permissions_backend_app_type_id__once = 0;
	if (g_once_init_enter (&permissions_backend_app_type_id__once)) {
		GType permissions_backend_app_type_id;
		permissions_backend_app_type_id = permissions_backend_app_get_type_once ();
		g_once_init_leave (&permissions_backend_app_type_id__once, permissions_backend_app_type_id);
	}
	return permissions_backend_app_type_id__once;
}

static void
_vala_permissions_backend_app_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 24 "../src/Permissions/Backend/App.vala"
	switch (property_id) {
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_object (value, permissions_backend_app_get_installed_ref (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_ID_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_string (value, permissions_backend_app_get_id (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_NAME_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		g_value_set_string (value, permissions_backend_app_get_name (self));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3433 "App.c"
		default:
#line 24 "../src/Permissions/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3439 "App.c"
	}
}

static void
_vala_permissions_backend_app_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PermissionsBackendApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PERMISSIONS_BACKEND_TYPE_APP, PermissionsBackendApp);
#line 24 "../src/Permissions/Backend/App.vala"
	switch (property_id) {
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_INSTALLED_REF_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_installed_ref (self, g_value_get_object (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_ID_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_id (self, g_value_get_string (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 24 "../src/Permissions/Backend/App.vala"
		case PERMISSIONS_BACKEND_APP_NAME_PROPERTY:
#line 24 "../src/Permissions/Backend/App.vala"
		permissions_backend_app_set_name (self, g_value_get_string (value));
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3471 "App.c"
		default:
#line 24 "../src/Permissions/Backend/App.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Permissions/Backend/App.vala"
		break;
#line 3477 "App.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

