/* Plug.c generated by valac 0.56.14, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
* Copyright 2014-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Akshay Shekher <voldyman666@gmail.com>
*              Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/

#include "applications.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

#define APPLICATIONS_PLUG_DEFAULTS "defaults"
#define APPLICATIONS_PLUG_STARTUP "startup"
#define APPLICATIONS_PLUG_PERMISSIONS "permissions"

enum  {
	APPLICATIONS_PLUG_0_PROPERTY,
	APPLICATIONS_PLUG_NUM_PROPERTIES
};
static GParamSpec* applications_plug_properties[APPLICATIONS_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ApplicationsPlugSearchData ApplicationsPlugSearchData;

struct _ApplicationsPlugPrivate {
	GtkGrid* grid;
	GtkStack* stack;
};

struct _ApplicationsPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationsPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
};

static gint ApplicationsPlug_private_offset;
static gpointer applications_plug_parent_class = NULL;

static GtkWidget* applications_plug_real_get_widget (SwitchboardPlug* base);
static void applications_plug_real_shown (SwitchboardPlug* base);
static void applications_plug_real_hidden (SwitchboardPlug* base);
static void applications_plug_real_search_callback (SwitchboardPlug* base,
                                             const gchar* location);
static void applications_plug_real_search_data_free (gpointer _data);
static void applications_plug_real_search (SwitchboardPlug* base,
                                    const gchar* search,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean applications_plug_real_search_co (ApplicationsPlugSearchData* _data_);
static void applications_plug_finalize (GObject * obj);
static GType applications_plug_get_type_once (void);

static inline gpointer
applications_plug_get_instance_private (ApplicationsPlug* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationsPlug_private_offset);
}

ApplicationsPlug*
applications_plug_construct (GType object_type)
{
	ApplicationsPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 32 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 33 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 35 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 35 "../src/Plug.vala"
	settings = _tmp0_;
#line 36 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "applications", NULL);
#line 37 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "applications/defaults", APPLICATIONS_PLUG_DEFAULTS);
#line 38 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "applications/startup", APPLICATIONS_PLUG_STARTUP);
#line 39 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "applications/permissions", APPLICATIONS_PLUG_PERMISSIONS);
#line 41 "../src/Plug.vala"
	self = (ApplicationsPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_PERSONAL, "code-name", "io.elementary.switchboard.applications", "description", _ ("Manage default apps, startup apps, and app permissions"), "display-name", _ ("Applications"), "icon", "io.elementary.settings.applications", "supported-settings", settings, NULL);
#line 31 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 31 "../src/Plug.vala"
	return self;
#line 174 "Plug.c"
}

ApplicationsPlug*
applications_plug_new (void)
{
#line 31 "../src/Plug.vala"
	return applications_plug_construct (TYPE_APPLICATIONS_PLUG);
#line 182 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 190 "Plug.c"
}

static GtkWidget*
applications_plug_real_get_widget (SwitchboardPlug* base)
{
	ApplicationsPlug * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp20_;
	GtkWidget* _tmp21_;
	GtkWidget* result;
#line 51 "../src/Plug.vala"
	self = (ApplicationsPlug*) base;
#line 52 "../src/Plug.vala"
	_tmp0_ = self->priv->grid;
#line 52 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 207 "Plug.c"
		GtkStack* _tmp1_ = NULL;
		GtkStack* _tmp2_;
		DefaultsPlug* _tmp3_;
		DefaultsPlug* _tmp4_;
		GtkStack* _tmp5_;
		StartupPlug* _tmp6_;
		StartupPlug* _tmp7_;
		GtkStack* _tmp8_;
		PermissionsPlug* _tmp9_;
		PermissionsPlug* _tmp10_;
		GtkStackSwitcher* stack_switcher = NULL;
		GtkStack* _tmp11_;
		GtkStack* _tmp12_;
		GtkStackSwitcher* _tmp13_ = NULL;
		GtkGrid* _tmp14_ = NULL;
		GtkGrid* _tmp15_;
		GtkStackSwitcher* _tmp16_;
		GtkGrid* _tmp17_;
		GtkStack* _tmp18_;
		GtkGrid* _tmp19_;
#line 53 "../src/Plug.vala"
		_tmp1_ = (GtkStack*) gtk_stack_new ();
#line 53 "../src/Plug.vala"
		g_object_set ((GtkWidget*) _tmp1_, "expand", TRUE, NULL);
#line 53 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 53 "../src/Plug.vala"
		_g_object_unref0 (self->priv->stack);
#line 53 "../src/Plug.vala"
		self->priv->stack = _tmp1_;
#line 56 "../src/Plug.vala"
		_tmp2_ = self->priv->stack;
#line 56 "../src/Plug.vala"
		_tmp3_ = defaults_plug_new ();
#line 56 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 56 "../src/Plug.vala"
		_tmp4_ = _tmp3_;
#line 56 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp2_, (GtkWidget*) _tmp4_, APPLICATIONS_PLUG_DEFAULTS, _ ("Defaults"));
#line 56 "../src/Plug.vala"
		_g_object_unref0 (_tmp4_);
#line 57 "../src/Plug.vala"
		_tmp5_ = self->priv->stack;
#line 57 "../src/Plug.vala"
		_tmp6_ = startup_plug_new ();
#line 57 "../src/Plug.vala"
		g_object_ref_sink (_tmp6_);
#line 57 "../src/Plug.vala"
		_tmp7_ = _tmp6_;
#line 57 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp5_, (GtkWidget*) _tmp7_, APPLICATIONS_PLUG_STARTUP, _ ("Startup"));
#line 57 "../src/Plug.vala"
		_g_object_unref0 (_tmp7_);
#line 58 "../src/Plug.vala"
		_tmp8_ = self->priv->stack;
#line 58 "../src/Plug.vala"
		_tmp9_ = permissions_plug_new ();
#line 58 "../src/Plug.vala"
		g_object_ref_sink (_tmp9_);
#line 58 "../src/Plug.vala"
		_tmp10_ = _tmp9_;
#line 58 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp8_, (GtkWidget*) _tmp10_, APPLICATIONS_PLUG_PERMISSIONS, _ ("Permissions"));
#line 58 "../src/Plug.vala"
		_g_object_unref0 (_tmp10_);
#line 60 "../src/Plug.vala"
		_tmp11_ = self->priv->stack;
#line 60 "../src/Plug.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 60 "../src/Plug.vala"
		_tmp13_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 60 "../src/Plug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
#line 60 "../src/Plug.vala"
		gtk_box_set_homogeneous ((GtkBox*) _tmp13_, TRUE);
#line 60 "../src/Plug.vala"
		gtk_stack_switcher_set_stack (_tmp13_, _tmp12_);
#line 60 "../src/Plug.vala"
		_g_object_unref0 (_tmp12_);
#line 60 "../src/Plug.vala"
		g_object_ref_sink (_tmp13_);
#line 60 "../src/Plug.vala"
		stack_switcher = _tmp13_;
#line 66 "../src/Plug.vala"
		_tmp14_ = (GtkGrid*) gtk_grid_new ();
#line 66 "../src/Plug.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp14_, 12);
#line 66 "../src/Plug.vala"
		gtk_grid_set_row_spacing (_tmp14_, 24);
#line 66 "../src/Plug.vala"
		g_object_ref_sink (_tmp14_);
#line 66 "../src/Plug.vala"
		_g_object_unref0 (self->priv->grid);
#line 66 "../src/Plug.vala"
		self->priv->grid = _tmp14_;
#line 70 "../src/Plug.vala"
		_tmp15_ = self->priv->grid;
#line 70 "../src/Plug.vala"
		_tmp16_ = stack_switcher;
#line 70 "../src/Plug.vala"
		gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp16_, 0, 0, 1, 1);
#line 71 "../src/Plug.vala"
		_tmp17_ = self->priv->grid;
#line 71 "../src/Plug.vala"
		_tmp18_ = self->priv->stack;
#line 71 "../src/Plug.vala"
		gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 0, 1, 1, 1);
#line 72 "../src/Plug.vala"
		_tmp19_ = self->priv->grid;
#line 72 "../src/Plug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp19_);
#line 52 "../src/Plug.vala"
		_g_object_unref0 (stack_switcher);
#line 322 "Plug.c"
	}
#line 75 "../src/Plug.vala"
	_tmp20_ = self->priv->grid;
#line 75 "../src/Plug.vala"
	_tmp21_ = _g_object_ref0 ((GtkWidget*) _tmp20_);
#line 75 "../src/Plug.vala"
	result = _tmp21_;
#line 75 "../src/Plug.vala"
	return result;
#line 332 "Plug.c"
}

static void
applications_plug_real_shown (SwitchboardPlug* base)
{
	ApplicationsPlug * self;
#line 78 "../src/Plug.vala"
	self = (ApplicationsPlug*) base;
#line 341 "Plug.c"
}

static void
applications_plug_real_hidden (SwitchboardPlug* base)
{
	ApplicationsPlug * self;
#line 81 "../src/Plug.vala"
	self = (ApplicationsPlug*) base;
#line 350 "Plug.c"
}

static void
applications_plug_real_search_callback (SwitchboardPlug* base,
                                        const gchar* location)
{
	ApplicationsPlug * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 85 "../src/Plug.vala"
	static GQuark _tmp1_label0 = 0;
#line 85 "../src/Plug.vala"
	static GQuark _tmp1_label1 = 0;
#line 85 "../src/Plug.vala"
	static GQuark _tmp1_label2 = 0;
#line 84 "../src/Plug.vala"
	self = (ApplicationsPlug*) base;
#line 84 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 85 "../src/Plug.vala"
	_tmp0_ = location;
#line 85 "../src/Plug.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 85 "../src/Plug.vala"
	if (((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (APPLICATIONS_PLUG_STARTUP)))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (APPLICATIONS_PLUG_DEFAULTS))))) || (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string (APPLICATIONS_PLUG_PERMISSIONS))))) {
#line 85 "../src/Plug.vala"
		switch (0) {
#line 378 "Plug.c"
			default:
			{
				GtkStack* _tmp3_;
#line 89 "../src/Plug.vala"
				_tmp3_ = self->priv->stack;
#line 89 "../src/Plug.vala"
				gtk_stack_set_visible_child_name (_tmp3_, location);
#line 90 "../src/Plug.vala"
				break;
#line 388 "Plug.c"
			}
		}
	} else {
#line 85 "../src/Plug.vala"
		switch (0) {
#line 394 "Plug.c"
			default:
			{
				GtkStack* _tmp4_;
#line 92 "../src/Plug.vala"
				_tmp4_ = self->priv->stack;
#line 92 "../src/Plug.vala"
				gtk_stack_set_visible_child_name (_tmp4_, APPLICATIONS_PLUG_DEFAULTS);
#line 93 "../src/Plug.vala"
				break;
#line 404 "Plug.c"
			}
		}
	}
}

static void
applications_plug_real_search_data_free (gpointer _data)
{
	ApplicationsPlugSearchData* _data_;
	_data_ = _data;
#line 23 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/Plug.vala"
	g_slice_free (ApplicationsPlugSearchData, _data_);
#line 423 "Plug.c"
}

static void
applications_plug_real_search (SwitchboardPlug* base,
                               const gchar* search,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ApplicationsPlug * self;
	ApplicationsPlugSearchData* _data_;
	ApplicationsPlug* _tmp0_;
	gchar* _tmp1_;
#line 23 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 23 "../src/Plug.vala"
	self = (ApplicationsPlug*) base;
#line 23 "../src/Plug.vala"
	_data_ = g_slice_new0 (ApplicationsPlugSearchData);
#line 23 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, applications_plug_real_search_data_free);
#line 23 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 23 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 23 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 23 "../src/Plug.vala"
	applications_plug_real_search_co (_data_);
#line 458 "Plug.c"
}

static GeeTreeMap*
applications_plug_search_finish (SwitchboardPlug* base,
                                 GAsyncResult* _res_)
{
	GeeTreeMap* result;
	ApplicationsPlugSearchData* _data_;
#line 23 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 23 "../src/Plug.vala"
	result = _data_->result;
#line 23 "../src/Plug.vala"
	_data_->result = NULL;
#line 23 "../src/Plug.vala"
	return result;
#line 475 "Plug.c"
}

static gboolean
applications_plug_real_search_co (ApplicationsPlugSearchData* _data_)
{
#line 97 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 97 "../src/Plug.vala"
		case 0:
#line 485 "Plug.c"
		goto _state_0;
		default:
#line 97 "../src/Plug.vala"
		g_assert_not_reached ();
#line 490 "Plug.c"
	}
	_state_0:
#line 98 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 98 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 98 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 98 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 102 "../src/Plug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 102 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 102 "../src/Plug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Startup"));
#line 102 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 102 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, APPLICATIONS_PLUG_STARTUP);
#line 102 "../src/Plug.vala"
	_g_free0 (_data_->_tmp6_);
#line 103 "../src/Plug.vala"
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 103 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 103 "../src/Plug.vala"
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("Default Apps"));
#line 103 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 103 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, APPLICATIONS_PLUG_DEFAULTS);
#line 103 "../src/Plug.vala"
	_g_free0 (_data_->_tmp10_);
#line 104 "../src/Plug.vala"
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 104 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 104 "../src/Plug.vala"
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Permissions"));
#line 104 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 104 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, APPLICATIONS_PLUG_PERMISSIONS);
#line 104 "../src/Plug.vala"
	_g_free0 (_data_->_tmp14_);
#line 105 "../src/Plug.vala"
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 105 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 105 "../src/Plug.vala"
	_data_->_tmp17_ = g_strdup_printf ("%s → %s", _data_->_tmp16_, _ ("Sandboxing"));
#line 105 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 105 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, APPLICATIONS_PLUG_PERMISSIONS);
#line 105 "../src/Plug.vala"
	_g_free0 (_data_->_tmp18_);
#line 106 "../src/Plug.vala"
	_data_->_tmp19_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 106 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 106 "../src/Plug.vala"
	_data_->_tmp21_ = g_strdup_printf ("%s → %s", _data_->_tmp20_, _ ("Confinement"));
#line 106 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 106 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp22_, APPLICATIONS_PLUG_PERMISSIONS);
#line 106 "../src/Plug.vala"
	_g_free0 (_data_->_tmp22_);
#line 107 "../src/Plug.vala"
	_data_->_tmp23_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 107 "../src/Plug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 107 "../src/Plug.vala"
	_data_->_tmp25_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp24_, _ ("Default"), _ ("Web Browser"));
#line 107 "../src/Plug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 107 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp26_, APPLICATIONS_PLUG_DEFAULTS);
#line 107 "../src/Plug.vala"
	_g_free0 (_data_->_tmp26_);
#line 108 "../src/Plug.vala"
	_data_->_tmp27_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 108 "../src/Plug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 108 "../src/Plug.vala"
	_data_->_tmp29_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp28_, _ ("Default"), _ ("Email Client"));
#line 108 "../src/Plug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 108 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp30_, APPLICATIONS_PLUG_DEFAULTS);
#line 108 "../src/Plug.vala"
	_g_free0 (_data_->_tmp30_);
#line 109 "../src/Plug.vala"
	_data_->_tmp31_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 109 "../src/Plug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 109 "../src/Plug.vala"
	_data_->_tmp33_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp32_, _ ("Default"), _ ("Calendar"));
#line 109 "../src/Plug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 109 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp34_, APPLICATIONS_PLUG_DEFAULTS);
#line 109 "../src/Plug.vala"
	_g_free0 (_data_->_tmp34_);
#line 110 "../src/Plug.vala"
	_data_->_tmp35_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 110 "../src/Plug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 110 "../src/Plug.vala"
	_data_->_tmp37_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp36_, _ ("Default"), _ ("Video Player"));
#line 110 "../src/Plug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 110 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp38_, APPLICATIONS_PLUG_DEFAULTS);
#line 110 "../src/Plug.vala"
	_g_free0 (_data_->_tmp38_);
#line 111 "../src/Plug.vala"
	_data_->_tmp39_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 111 "../src/Plug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 111 "../src/Plug.vala"
	_data_->_tmp41_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp40_, _ ("Default"), _ ("Music Player"));
#line 111 "../src/Plug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 111 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp42_, APPLICATIONS_PLUG_DEFAULTS);
#line 111 "../src/Plug.vala"
	_g_free0 (_data_->_tmp42_);
#line 112 "../src/Plug.vala"
	_data_->_tmp43_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 112 "../src/Plug.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 112 "../src/Plug.vala"
	_data_->_tmp45_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp44_, _ ("Default"), _ ("Text Editor"));
#line 112 "../src/Plug.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 112 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp46_, APPLICATIONS_PLUG_DEFAULTS);
#line 112 "../src/Plug.vala"
	_g_free0 (_data_->_tmp46_);
#line 113 "../src/Plug.vala"
	_data_->_tmp47_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 113 "../src/Plug.vala"
	_data_->_tmp48_ = _data_->_tmp47_;
#line 113 "../src/Plug.vala"
	_data_->_tmp49_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp48_, _ ("Default"), _ ("Image Viewer"));
#line 113 "../src/Plug.vala"
	_data_->_tmp50_ = _data_->_tmp49_;
#line 113 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp50_, APPLICATIONS_PLUG_DEFAULTS);
#line 113 "../src/Plug.vala"
	_g_free0 (_data_->_tmp50_);
#line 114 "../src/Plug.vala"
	_data_->_tmp51_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 114 "../src/Plug.vala"
	_data_->_tmp52_ = _data_->_tmp51_;
#line 114 "../src/Plug.vala"
	_data_->_tmp53_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp52_, _ ("Default"), _ ("File Browser"));
#line 114 "../src/Plug.vala"
	_data_->_tmp54_ = _data_->_tmp53_;
#line 114 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp54_, APPLICATIONS_PLUG_DEFAULTS);
#line 114 "../src/Plug.vala"
	_g_free0 (_data_->_tmp54_);
#line 115 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 115 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 115 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 115 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 115 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 667 "Plug.c"
		}
	}
#line 115 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 115 "../src/Plug.vala"
	return FALSE;
#line 674 "Plug.c"
}

static void
applications_plug_class_init (ApplicationsPlugClass * klass,
                              gpointer klass_data)
{
#line 23 "../src/Plug.vala"
	applications_plug_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationsPlug_private_offset);
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) applications_plug_real_get_widget;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) applications_plug_real_shown;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) applications_plug_real_hidden;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) applications_plug_real_search_callback;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) applications_plug_real_search;
#line 23 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) applications_plug_search_finish;
#line 23 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = applications_plug_finalize;
#line 699 "Plug.c"
}

static void
applications_plug_instance_init (ApplicationsPlug * self,
                                 gpointer klass)
{
#line 23 "../src/Plug.vala"
	self->priv = applications_plug_get_instance_private (self);
#line 708 "Plug.c"
}

static void
applications_plug_finalize (GObject * obj)
{
	ApplicationsPlug * self;
#line 23 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATIONS_PLUG, ApplicationsPlug);
#line 28 "../src/Plug.vala"
	_g_object_unref0 (self->priv->grid);
#line 29 "../src/Plug.vala"
	_g_object_unref0 (self->priv->stack);
#line 23 "../src/Plug.vala"
	G_OBJECT_CLASS (applications_plug_parent_class)->finalize (obj);
#line 723 "Plug.c"
}

static GType
applications_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationsPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) applications_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationsPlug), 0, (GInstanceInitFunc) applications_plug_instance_init, NULL };
	GType applications_plug_type_id;
	applications_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "ApplicationsPlug", &g_define_type_info, 0);
	ApplicationsPlug_private_offset = g_type_add_instance_private (applications_plug_type_id, sizeof (ApplicationsPlugPrivate));
	return applications_plug_type_id;
}

GType
applications_plug_get_type (void)
{
	static volatile gsize applications_plug_type_id__once = 0;
	if (g_once_init_enter (&applications_plug_type_id__once)) {
		GType applications_plug_type_id;
		applications_plug_type_id = applications_plug_get_type_once ();
		g_once_init_leave (&applications_plug_type_id__once, applications_plug_type_id);
	}
	return applications_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	ApplicationsPlug* _tmp0_;
	SwitchboardPlug* result;
#line 120 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 121 "../src/Plug.vala"
	_tmp0_ = applications_plug_new ();
#line 121 "../src/Plug.vala"
	result = (SwitchboardPlug*) _tmp0_;
#line 121 "../src/Plug.vala"
	return result;
#line 761 "Plug.c"
}

