/* KeyFile.c generated by valac 0.56.14, the Vala compiler
 * generated from KeyFile.vala, do not modify */

/*
* Copyright 2013-2023 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include "applications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#define STARTUP_BACKEND_KEY_FILE_FALLBACK_ICON "application-default-icon"
#define STARTUP_BACKEND_KEY_FILE_KEY_GNOME_AUTOSTART_ENABLED "X-GNOME-Autostart-enabled"

enum  {
	STARTUP_BACKEND_KEY_FILE_0_PROPERTY,
	STARTUP_BACKEND_KEY_FILE_ACTIVE_PROPERTY,
	STARTUP_BACKEND_KEY_FILE_SHOW_PROPERTY,
	STARTUP_BACKEND_KEY_FILE_PATH_PROPERTY,
	STARTUP_BACKEND_KEY_FILE_NUM_PROPERTIES
};
static GParamSpec* startup_backend_key_file_properties[STARTUP_BACKEND_KEY_FILE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _StartupBackendKeyFilePrivate {
	gchar* _path;
	GKeyFile* keyfile;
};

static gint StartupBackendKeyFile_private_offset;
static gpointer startup_backend_key_file_parent_class = NULL;
static gchar** startup_backend_key_file_languages;
static gint startup_backend_key_file_languages_length1;
static gchar** startup_backend_key_file_languages = NULL;
static gint startup_backend_key_file_languages_length1 = 0;
static gint _startup_backend_key_file_languages_size_ = 0;
static gchar* startup_backend_key_file_preferred_language;
static gchar* startup_backend_key_file_preferred_language = NULL;

static gchar* startup_backend_key_file_create_path_for_custom_command (StartupBackendKeyFile* self);
static gchar* startup_backend_key_file_keyfile_get_locale_string (StartupBackendKeyFile* self,
                                                           const gchar* key);
static gchar* startup_backend_key_file_keyfile_get_string (StartupBackendKeyFile* self,
                                                    const gchar* key);
static gboolean startup_backend_key_file_keyfile_get_bool (StartupBackendKeyFile* self,
                                                    const gchar* key);
static gboolean startup_backend_key_file_keyfile_has_key (StartupBackendKeyFile* self,
                                                   const gchar* key);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static void startup_backend_key_file_finalize (GObject * obj);
static GType startup_backend_key_file_get_type_once (void);
static void _vala_startup_backend_key_file_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_startup_backend_key_file_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
startup_backend_key_file_get_instance_private (StartupBackendKeyFile* self)
{
	return G_STRUCT_MEMBER_P (self, StartupBackendKeyFile_private_offset);
}

StartupBackendKeyFile*
startup_backend_key_file_construct (GType object_type,
                                    const gchar* path)
{
	StartupBackendKeyFile * self = NULL;
	GKeyFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 85 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 86 "../src/Startup/Backend/KeyFile.vala"
	self = (StartupBackendKeyFile*) g_object_new (object_type, "path", path, NULL);
#line 87 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = g_key_file_new ();
#line 87 "../src/Startup/Backend/KeyFile.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 87 "../src/Startup/Backend/KeyFile.vala"
	self->priv->keyfile = _tmp0_;
#line 123 "KeyFile.c"
	{
		GKeyFile* _tmp1_;
#line 90 "../src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 90 "../src/Startup/Backend/KeyFile.vala"
		g_key_file_load_from_file (_tmp1_, path, G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error0_);
#line 90 "../src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "KeyFile.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 89 "../src/Startup/Backend/KeyFile.vala"
		e = _inner_error0_;
#line 89 "../src/Startup/Backend/KeyFile.vala"
		_inner_error0_ = NULL;
#line 92 "../src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:92: Failed to load contents of file '%s'", path);
#line 93 "../src/Startup/Backend/KeyFile.vala"
		_tmp2_ = e;
#line 93 "../src/Startup/Backend/KeyFile.vala"
		_tmp3_ = _tmp2_->message;
#line 93 "../src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:93: %s", _tmp3_);
#line 89 "../src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 156 "KeyFile.c"
	}
	__finally0:
#line 89 "../src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error0_);
#line 89 "../src/Startup/Backend/KeyFile.vala"
		return NULL;
#line 167 "KeyFile.c"
	}
#line 85 "../src/Startup/Backend/KeyFile.vala"
	return self;
#line 171 "KeyFile.c"
}

StartupBackendKeyFile*
startup_backend_key_file_new (const gchar* path)
{
#line 85 "../src/Startup/Backend/KeyFile.vala"
	return startup_backend_key_file_construct (STARTUP_BACKEND_TYPE_KEY_FILE, path);
#line 179 "KeyFile.c"
}

StartupBackendKeyFile*
startup_backend_key_file_construct_from_command (GType object_type,
                                                 const gchar* command)
{
	StartupBackendKeyFile * self = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	const gchar* _tmp2_;
	GKeyFile* _tmp3_;
	const gchar* _tmp4_;
	GKeyFile* _tmp5_;
	GKeyFile* _tmp6_;
	GKeyFile* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 97 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 97 "../src/Startup/Backend/KeyFile.vala"
	self = (StartupBackendKeyFile*) g_object_new (object_type, NULL);
#line 98 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = g_key_file_new ();
#line 98 "../src/Startup/Backend/KeyFile.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 98 "../src/Startup/Backend/KeyFile.vala"
	self->priv->keyfile = _tmp0_;
#line 99 "../src/Startup/Backend/KeyFile.vala"
	_tmp1_ = self->priv->keyfile;
#line 99 "../src/Startup/Backend/KeyFile.vala"
	_tmp2_ = startup_backend_key_file_preferred_language;
#line 99 "../src/Startup/Backend/KeyFile.vala"
	g_key_file_set_locale_string (_tmp1_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_NAME, _tmp2_, _ ("Custom Command"));
#line 100 "../src/Startup/Backend/KeyFile.vala"
	_tmp3_ = self->priv->keyfile;
#line 100 "../src/Startup/Backend/KeyFile.vala"
	_tmp4_ = startup_backend_key_file_preferred_language;
#line 100 "../src/Startup/Backend/KeyFile.vala"
	g_key_file_set_locale_string (_tmp3_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_COMMENT, _tmp4_, command);
#line 101 "../src/Startup/Backend/KeyFile.vala"
	_tmp5_ = self->priv->keyfile;
#line 101 "../src/Startup/Backend/KeyFile.vala"
	g_key_file_set_string (_tmp5_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, command);
#line 102 "../src/Startup/Backend/KeyFile.vala"
	_tmp6_ = self->priv->keyfile;
#line 102 "../src/Startup/Backend/KeyFile.vala"
	g_key_file_set_string (_tmp6_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, STARTUP_BACKEND_KEY_FILE_FALLBACK_ICON);
#line 103 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_ = self->priv->keyfile;
#line 103 "../src/Startup/Backend/KeyFile.vala"
	g_key_file_set_string (_tmp7_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, G_KEY_FILE_DESKTOP_TYPE_APPLICATION);
#line 105 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_active (self, TRUE);
#line 106 "../src/Startup/Backend/KeyFile.vala"
	_tmp8_ = startup_backend_key_file_create_path_for_custom_command (self);
#line 106 "../src/Startup/Backend/KeyFile.vala"
	_tmp9_ = _tmp8_;
#line 106 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_path (self, _tmp9_);
#line 106 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp9_);
#line 108 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_write_to_file (self);
#line 97 "../src/Startup/Backend/KeyFile.vala"
	return self;
#line 245 "KeyFile.c"
}

StartupBackendKeyFile*
startup_backend_key_file_new_from_command (const gchar* command)
{
#line 97 "../src/Startup/Backend/KeyFile.vala"
	return startup_backend_key_file_construct_from_command (STARTUP_BACKEND_TYPE_KEY_FILE, command);
#line 253 "KeyFile.c"
}

static gchar*
startup_backend_key_file_create_path_for_custom_command (StartupBackendKeyFile* self)
{
	gchar* startup_dir = NULL;
	gchar* _tmp0_;
	gchar* _tmp11_;
	gchar* result;
#line 111 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_utils_get_user_startup_dir ();
#line 112 "../src/Startup/Backend/KeyFile.vala"
	startup_dir = _tmp0_;
#line 269 "KeyFile.c"
	{
		gint i = 0;
#line 114 "../src/Startup/Backend/KeyFile.vala"
		i = 0;
#line 274 "KeyFile.c"
		{
			gboolean _tmp1_ = FALSE;
#line 114 "../src/Startup/Backend/KeyFile.vala"
			_tmp1_ = TRUE;
#line 114 "../src/Startup/Backend/KeyFile.vala"
			while (TRUE) {
#line 281 "KeyFile.c"
				gchar* filename = NULL;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
#line 114 "../src/Startup/Backend/KeyFile.vala"
				if (!_tmp1_) {
#line 293 "KeyFile.c"
					gint _tmp2_;
#line 114 "../src/Startup/Backend/KeyFile.vala"
					_tmp2_ = i;
#line 114 "../src/Startup/Backend/KeyFile.vala"
					i = _tmp2_ + 1;
#line 299 "KeyFile.c"
				}
#line 114 "../src/Startup/Backend/KeyFile.vala"
				_tmp1_ = FALSE;
#line 114 "../src/Startup/Backend/KeyFile.vala"
				if (!(i < 100)) {
#line 114 "../src/Startup/Backend/KeyFile.vala"
					break;
#line 307 "KeyFile.c"
				}
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp3_ = startup_dir;
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp4_ = g_strdup_printf ("%i", i);
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp5_ = _tmp4_;
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp6_ = g_strconcat ("custom-command", _tmp5_, ".desktop", NULL);
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp7_ = _tmp6_;
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp8_ = g_build_filename (_tmp3_, _tmp7_, NULL);
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_tmp9_ = _tmp8_;
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_g_free0 (_tmp7_);
#line 115 "../src/Startup/Backend/KeyFile.vala"
				_g_free0 (_tmp5_);
#line 115 "../src/Startup/Backend/KeyFile.vala"
				filename = _tmp9_;
#line 116 "../src/Startup/Backend/KeyFile.vala"
				_tmp10_ = filename;
#line 116 "../src/Startup/Backend/KeyFile.vala"
				if (g_file_test (_tmp10_, G_FILE_TEST_EXISTS) == FALSE) {
#line 117 "../src/Startup/Backend/KeyFile.vala"
					result = filename;
#line 117 "../src/Startup/Backend/KeyFile.vala"
					_g_free0 (startup_dir);
#line 117 "../src/Startup/Backend/KeyFile.vala"
					return result;
#line 339 "KeyFile.c"
				}
#line 114 "../src/Startup/Backend/KeyFile.vala"
				_g_free0 (filename);
#line 343 "KeyFile.c"
			}
		}
	}
#line 122 "../src/Startup/Backend/KeyFile.vala"
	_tmp11_ = g_strdup ("");
#line 122 "../src/Startup/Backend/KeyFile.vala"
	result = _tmp11_;
#line 122 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (startup_dir);
#line 122 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 355 "KeyFile.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 364 "KeyFile.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 372 "KeyFile.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 381 "KeyFile.c"
	}
}

void
startup_backend_key_file_write_to_file (StartupBackendKeyFile* self)
{
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 125 "../src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 404 "KeyFile.c"
	{
		const gchar* _tmp0_;
		GKeyFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 127 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = self->priv->_path;
#line 127 "../src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 127 "../src/Startup/Backend/KeyFile.vala"
		_tmp2_ = g_key_file_to_data (_tmp1_, NULL, NULL);
#line 127 "../src/Startup/Backend/KeyFile.vala"
		_tmp3_ = _tmp2_;
#line 127 "../src/Startup/Backend/KeyFile.vala"
		g_file_set_contents (_tmp0_, _tmp3_, (gssize) -1, &_inner_error0_);
#line 127 "../src/Startup/Backend/KeyFile.vala"
		_g_free0 (_tmp3_);
#line 127 "../src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "KeyFile.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 126 "../src/Startup/Backend/KeyFile.vala"
		e = _inner_error0_;
#line 126 "../src/Startup/Backend/KeyFile.vala"
		_inner_error0_ = NULL;
#line 129 "../src/Startup/Backend/KeyFile.vala"
		_tmp4_ = self->priv->_path;
#line 129 "../src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:129: Could not write to file %s", _tmp4_);
#line 130 "../src/Startup/Backend/KeyFile.vala"
		_tmp5_ = e;
#line 130 "../src/Startup/Backend/KeyFile.vala"
		_tmp6_ = _tmp5_->message;
#line 130 "../src/Startup/Backend/KeyFile.vala"
		g_warning ("KeyFile.vala:130: %s", _tmp6_);
#line 126 "../src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 451 "KeyFile.c"
	}
	__finally0:
#line 126 "../src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "../src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "../src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error0_);
#line 126 "../src/Startup/Backend/KeyFile.vala"
		return;
#line 462 "KeyFile.c"
	}
#line 133 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_ = self->priv->_path;
#line 133 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:133: -- Saving to %s --", _tmp7_);
#line 134 "../src/Startup/Backend/KeyFile.vala"
	_tmp8_ = startup_backend_key_file_keyfile_get_locale_string (self, G_KEY_FILE_DESKTOP_KEY_NAME);
#line 134 "../src/Startup/Backend/KeyFile.vala"
	_tmp9_ = _tmp8_;
#line 134 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:134: Name:    %s", _tmp9_);
#line 134 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp9_);
#line 135 "../src/Startup/Backend/KeyFile.vala"
	_tmp10_ = startup_backend_key_file_keyfile_get_locale_string (self, G_KEY_FILE_DESKTOP_KEY_COMMENT);
#line 135 "../src/Startup/Backend/KeyFile.vala"
	_tmp11_ = _tmp10_;
#line 135 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:135: Comment: %s", _tmp11_);
#line 135 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp11_);
#line 136 "../src/Startup/Backend/KeyFile.vala"
	_tmp12_ = startup_backend_key_file_keyfile_get_string (self, G_KEY_FILE_DESKTOP_KEY_EXEC);
#line 136 "../src/Startup/Backend/KeyFile.vala"
	_tmp13_ = _tmp12_;
#line 136 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:136: Command: %s", _tmp13_);
#line 136 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp13_);
#line 137 "../src/Startup/Backend/KeyFile.vala"
	_tmp14_ = startup_backend_key_file_keyfile_get_string (self, G_KEY_FILE_DESKTOP_KEY_ICON);
#line 137 "../src/Startup/Backend/KeyFile.vala"
	_tmp15_ = _tmp14_;
#line 137 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:137: Icon:    %s", _tmp15_);
#line 137 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp15_);
#line 138 "../src/Startup/Backend/KeyFile.vala"
	_tmp16_ = startup_backend_key_file_get_active (self);
#line 138 "../src/Startup/Backend/KeyFile.vala"
	_tmp17_ = _tmp16_;
#line 138 "../src/Startup/Backend/KeyFile.vala"
	_tmp18_ = bool_to_string (_tmp17_);
#line 138 "../src/Startup/Backend/KeyFile.vala"
	_tmp19_ = _tmp18_;
#line 138 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:138: Active:  %s", _tmp19_);
#line 138 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp19_);
#line 139 "../src/Startup/Backend/KeyFile.vala"
	g_debug ("KeyFile.vala:139: -- Done --");
#line 514 "KeyFile.c"
}

static gboolean
startup_backend_key_file_keyfile_get_bool (StartupBackendKeyFile* self,
                                           const gchar* key)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 142 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 527 "KeyFile.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
#line 144 "../src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 144 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = g_key_file_get_boolean (_tmp1_, G_KEY_FILE_DESKTOP_GROUP, key, &_inner_error0_);
#line 144 "../src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 537 "KeyFile.c"
			gboolean _tmp2_ = FALSE;
#line 144 "../src/Startup/Backend/KeyFile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 541 "KeyFile.c"
				goto __catch0_g_key_file_error;
			}
#line 144 "../src/Startup/Backend/KeyFile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/Startup/Backend/KeyFile.vala"
			g_clear_error (&_inner_error0_);
#line 144 "../src/Startup/Backend/KeyFile.vala"
			return _tmp2_;
#line 550 "KeyFile.c"
		}
#line 144 "../src/Startup/Backend/KeyFile.vala"
		result = _tmp0_;
#line 144 "../src/Startup/Backend/KeyFile.vala"
		return result;
#line 556 "KeyFile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 143 "../src/Startup/Backend/KeyFile.vala"
		e = _inner_error0_;
#line 143 "../src/Startup/Backend/KeyFile.vala"
		_inner_error0_ = NULL;
#line 146 "../src/Startup/Backend/KeyFile.vala"
		_tmp3_ = e;
#line 146 "../src/Startup/Backend/KeyFile.vala"
		_tmp4_ = _tmp3_->message;
#line 146 "../src/Startup/Backend/KeyFile.vala"
		g_debug ("KeyFile.vala:146: %s", _tmp4_);
#line 143 "../src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 576 "KeyFile.c"
	}
	__finally0:
#line 143 "../src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 581 "KeyFile.c"
		gboolean _tmp5_ = FALSE;
#line 143 "../src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error0_);
#line 143 "../src/Startup/Backend/KeyFile.vala"
		return _tmp5_;
#line 589 "KeyFile.c"
	}
#line 149 "../src/Startup/Backend/KeyFile.vala"
	result = FALSE;
#line 149 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 595 "KeyFile.c"
}

static gchar*
startup_backend_key_file_keyfile_get_string (StartupBackendKeyFile* self,
                                             const gchar* key)
{
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 152 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 609 "KeyFile.c"
	{
		gchar* _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 154 "../src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 154 "../src/Startup/Backend/KeyFile.vala"
		_tmp2_ = g_key_file_get_string (_tmp1_, G_KEY_FILE_DESKTOP_GROUP, key, &_inner_error0_);
#line 154 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = _tmp2_;
#line 154 "../src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/Startup/Backend/KeyFile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 625 "KeyFile.c"
				goto __catch0_g_key_file_error;
			}
#line 154 "../src/Startup/Backend/KeyFile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/Startup/Backend/KeyFile.vala"
			g_clear_error (&_inner_error0_);
#line 154 "../src/Startup/Backend/KeyFile.vala"
			return NULL;
#line 634 "KeyFile.c"
		}
#line 154 "../src/Startup/Backend/KeyFile.vala"
		_tmp3_ = _tmp0_;
#line 154 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = NULL;
#line 154 "../src/Startup/Backend/KeyFile.vala"
		result = _tmp3_;
#line 154 "../src/Startup/Backend/KeyFile.vala"
		_g_free0 (_tmp0_);
#line 154 "../src/Startup/Backend/KeyFile.vala"
		return result;
#line 646 "KeyFile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 153 "../src/Startup/Backend/KeyFile.vala"
		e = _inner_error0_;
#line 153 "../src/Startup/Backend/KeyFile.vala"
		_inner_error0_ = NULL;
#line 156 "../src/Startup/Backend/KeyFile.vala"
		_tmp4_ = e;
#line 156 "../src/Startup/Backend/KeyFile.vala"
		_tmp5_ = _tmp4_->message;
#line 156 "../src/Startup/Backend/KeyFile.vala"
		g_debug ("KeyFile.vala:156: %s", _tmp5_);
#line 153 "../src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 666 "KeyFile.c"
	}
	__finally0:
#line 153 "../src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "../src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 153 "../src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error0_);
#line 153 "../src/Startup/Backend/KeyFile.vala"
		return NULL;
#line 677 "KeyFile.c"
	}
#line 159 "../src/Startup/Backend/KeyFile.vala"
	_tmp6_ = g_strdup ("");
#line 159 "../src/Startup/Backend/KeyFile.vala"
	result = _tmp6_;
#line 159 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 685 "KeyFile.c"
}

static gchar*
startup_backend_key_file_keyfile_get_locale_string (StartupBackendKeyFile* self,
                                                    const gchar* key)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 162 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 163 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_languages;
#line 163 "../src/Startup/Backend/KeyFile.vala"
	_tmp0__length1 = startup_backend_key_file_languages_length1;
#line 705 "KeyFile.c"
	{
		gchar** lang_collection = NULL;
		gint lang_collection_length1 = 0;
		gint _lang_collection_size_ = 0;
		gint lang_it = 0;
#line 163 "../src/Startup/Backend/KeyFile.vala"
		lang_collection = _tmp0_;
#line 163 "../src/Startup/Backend/KeyFile.vala"
		lang_collection_length1 = _tmp0__length1;
#line 163 "../src/Startup/Backend/KeyFile.vala"
		for (lang_it = 0; lang_it < lang_collection_length1; lang_it = lang_it + 1) {
#line 717 "KeyFile.c"
			gchar* _tmp1_;
			gchar* lang = NULL;
#line 163 "../src/Startup/Backend/KeyFile.vala"
			_tmp1_ = g_strdup (lang_collection[lang_it]);
#line 163 "../src/Startup/Backend/KeyFile.vala"
			lang = _tmp1_;
#line 724 "KeyFile.c"
			{
				{
					gchar* _tmp2_ = NULL;
					GKeyFile* _tmp3_;
					const gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_tmp3_ = self->priv->keyfile;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_tmp4_ = lang;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_tmp5_ = g_key_file_get_locale_string (_tmp3_, G_KEY_FILE_DESKTOP_GROUP, key, _tmp4_, &_inner_error0_);
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_tmp2_ = _tmp5_;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../src/Startup/Backend/KeyFile.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 744 "KeyFile.c"
							goto __catch0_g_key_file_error;
						}
#line 165 "../src/Startup/Backend/KeyFile.vala"
						_g_free0 (lang);
#line 165 "../src/Startup/Backend/KeyFile.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/Startup/Backend/KeyFile.vala"
						g_clear_error (&_inner_error0_);
#line 165 "../src/Startup/Backend/KeyFile.vala"
						return NULL;
#line 755 "KeyFile.c"
					}
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_tmp6_ = _tmp2_;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_tmp2_ = NULL;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					result = _tmp6_;
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_g_free0 (_tmp2_);
#line 165 "../src/Startup/Backend/KeyFile.vala"
					_g_free0 (lang);
#line 165 "../src/Startup/Backend/KeyFile.vala"
					return result;
#line 769 "KeyFile.c"
				}
				goto __finally0;
				__catch0_g_key_file_error:
				{
					GError* e = NULL;
					GError* _tmp7_;
					const gchar* _tmp8_;
#line 164 "../src/Startup/Backend/KeyFile.vala"
					e = _inner_error0_;
#line 164 "../src/Startup/Backend/KeyFile.vala"
					_inner_error0_ = NULL;
#line 167 "../src/Startup/Backend/KeyFile.vala"
					_tmp7_ = e;
#line 167 "../src/Startup/Backend/KeyFile.vala"
					_tmp8_ = _tmp7_->message;
#line 167 "../src/Startup/Backend/KeyFile.vala"
					g_debug ("KeyFile.vala:167: %s", _tmp8_);
#line 164 "../src/Startup/Backend/KeyFile.vala"
					_g_error_free0 (e);
#line 789 "KeyFile.c"
				}
				__finally0:
#line 164 "../src/Startup/Backend/KeyFile.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/Startup/Backend/KeyFile.vala"
					_g_free0 (lang);
#line 164 "../src/Startup/Backend/KeyFile.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/Startup/Backend/KeyFile.vala"
					g_clear_error (&_inner_error0_);
#line 164 "../src/Startup/Backend/KeyFile.vala"
					return NULL;
#line 802 "KeyFile.c"
				}
#line 163 "../src/Startup/Backend/KeyFile.vala"
				_g_free0 (lang);
#line 806 "KeyFile.c"
			}
		}
	}
#line 171 "../src/Startup/Backend/KeyFile.vala"
	_tmp9_ = g_strdup ("");
#line 171 "../src/Startup/Backend/KeyFile.vala"
	result = _tmp9_;
#line 171 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 816 "KeyFile.c"
}

static gboolean
startup_backend_key_file_keyfile_has_key (StartupBackendKeyFile* self,
                                          const gchar* key)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 174 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 174 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 829 "KeyFile.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
#line 176 "../src/Startup/Backend/KeyFile.vala"
		_tmp1_ = self->priv->keyfile;
#line 176 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = g_key_file_has_key (_tmp1_, G_KEY_FILE_DESKTOP_GROUP, key, &_inner_error0_);
#line 176 "../src/Startup/Backend/KeyFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 839 "KeyFile.c"
			gboolean _tmp2_ = FALSE;
#line 176 "../src/Startup/Backend/KeyFile.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 843 "KeyFile.c"
				goto __catch0_g_key_file_error;
			}
#line 176 "../src/Startup/Backend/KeyFile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/Startup/Backend/KeyFile.vala"
			g_clear_error (&_inner_error0_);
#line 176 "../src/Startup/Backend/KeyFile.vala"
			return _tmp2_;
#line 852 "KeyFile.c"
		}
#line 176 "../src/Startup/Backend/KeyFile.vala"
		result = _tmp0_;
#line 176 "../src/Startup/Backend/KeyFile.vala"
		return result;
#line 858 "KeyFile.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 175 "../src/Startup/Backend/KeyFile.vala"
		e = _inner_error0_;
#line 175 "../src/Startup/Backend/KeyFile.vala"
		_inner_error0_ = NULL;
#line 178 "../src/Startup/Backend/KeyFile.vala"
		_tmp3_ = e;
#line 178 "../src/Startup/Backend/KeyFile.vala"
		_tmp4_ = _tmp3_->message;
#line 178 "../src/Startup/Backend/KeyFile.vala"
		g_debug ("KeyFile.vala:178: %s", _tmp4_);
#line 175 "../src/Startup/Backend/KeyFile.vala"
		_g_error_free0 (e);
#line 878 "KeyFile.c"
	}
	__finally0:
#line 175 "../src/Startup/Backend/KeyFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 883 "KeyFile.c"
		gboolean _tmp5_ = FALSE;
#line 175 "../src/Startup/Backend/KeyFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 175 "../src/Startup/Backend/KeyFile.vala"
		g_clear_error (&_inner_error0_);
#line 175 "../src/Startup/Backend/KeyFile.vala"
		return _tmp5_;
#line 891 "KeyFile.c"
	}
#line 181 "../src/Startup/Backend/KeyFile.vala"
	result = FALSE;
#line 181 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 897 "KeyFile.c"
}

void
startup_backend_key_file_copy_to_local (StartupBackendKeyFile* self)
{
	const gchar* _tmp0_;
	gchar* basename = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* startup_dir = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 184 "../src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->_path;
#line 184 "../src/Startup/Backend/KeyFile.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "path != null");
#line 185 "../src/Startup/Backend/KeyFile.vala"
	_tmp1_ = self->priv->_path;
#line 185 "../src/Startup/Backend/KeyFile.vala"
	_tmp2_ = g_path_get_basename (_tmp1_);
#line 185 "../src/Startup/Backend/KeyFile.vala"
	basename = _tmp2_;
#line 186 "../src/Startup/Backend/KeyFile.vala"
	_tmp3_ = startup_utils_get_user_startup_dir ();
#line 186 "../src/Startup/Backend/KeyFile.vala"
	startup_dir = _tmp3_;
#line 187 "../src/Startup/Backend/KeyFile.vala"
	_tmp4_ = g_build_filename (startup_dir, basename, NULL);
#line 187 "../src/Startup/Backend/KeyFile.vala"
	_tmp5_ = _tmp4_;
#line 187 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_set_path (self, _tmp5_);
#line 187 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp5_);
#line 188 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_write_to_file (self);
#line 184 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (startup_dir);
#line 184 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (basename);
#line 941 "KeyFile.c"
}

void
startup_backend_key_file_create_app_info (StartupBackendKeyFile* self,
                                          StartupEntityAppInfo* result)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	StartupEntityAppInfo _tmp7_ = {0};
#line 191 "../src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = startup_backend_key_file_keyfile_get_locale_string (self, G_KEY_FILE_DESKTOP_KEY_NAME);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp1_ = startup_backend_key_file_keyfile_get_locale_string (self, G_KEY_FILE_DESKTOP_KEY_COMMENT);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp2_ = startup_backend_key_file_keyfile_get_locale_string (self, G_KEY_FILE_DESKTOP_KEY_ICON);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp3_ = startup_backend_key_file_get_active (self);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp4_ = _tmp3_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp5_ = self->priv->_path;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	memset (&_tmp7_, 0, sizeof (StartupEntityAppInfo));
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp7_.name);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_.name = _tmp0_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp7_.comment);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_.comment = _tmp1_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp7_.icon);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_.icon = _tmp2_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_.active = _tmp4_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp7_.path);
#line 192 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_.path = _tmp6_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	*result = _tmp7_;
#line 192 "../src/Startup/Backend/KeyFile.vala"
	return;
#line 996 "KeyFile.c"
}

gboolean
startup_backend_key_file_get_active (StartupBackendKeyFile* self)
{
	gboolean result;
#line 32 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/Startup/Backend/KeyFile.vala"
	if (startup_backend_key_file_keyfile_has_key (self, STARTUP_BACKEND_KEY_FILE_KEY_GNOME_AUTOSTART_ENABLED)) {
#line 34 "../src/Startup/Backend/KeyFile.vala"
		result = startup_backend_key_file_keyfile_get_bool (self, STARTUP_BACKEND_KEY_FILE_KEY_GNOME_AUTOSTART_ENABLED);
#line 34 "../src/Startup/Backend/KeyFile.vala"
		return result;
#line 1011 "KeyFile.c"
	}
#line 37 "../src/Startup/Backend/KeyFile.vala"
	result = !startup_backend_key_file_keyfile_get_bool (self, G_KEY_FILE_DESKTOP_KEY_HIDDEN);
#line 37 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 1017 "KeyFile.c"
}

void
startup_backend_key_file_set_active (StartupBackendKeyFile* self,
                                     gboolean value)
{
	GKeyFile* _tmp1_;
#line 40 "../src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Startup/Backend/KeyFile.vala"
	if (startup_backend_key_file_keyfile_has_key (self, STARTUP_BACKEND_KEY_FILE_KEY_GNOME_AUTOSTART_ENABLED)) {
#line 1029 "KeyFile.c"
		GKeyFile* _tmp0_;
#line 42 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = self->priv->keyfile;
#line 42 "../src/Startup/Backend/KeyFile.vala"
		g_key_file_set_boolean (_tmp0_, G_KEY_FILE_DESKTOP_GROUP, STARTUP_BACKEND_KEY_FILE_KEY_GNOME_AUTOSTART_ENABLED, value);
#line 43 "../src/Startup/Backend/KeyFile.vala"
		return;
#line 1037 "KeyFile.c"
	}
#line 46 "../src/Startup/Backend/KeyFile.vala"
	_tmp1_ = self->priv->keyfile;
#line 46 "../src/Startup/Backend/KeyFile.vala"
	g_key_file_set_boolean (_tmp1_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_HIDDEN, !value);
#line 40 "../src/Startup/Backend/KeyFile.vala"
	g_object_notify_by_pspec ((GObject *) self, startup_backend_key_file_properties[STARTUP_BACKEND_KEY_FILE_ACTIVE_PROPERTY]);
#line 1045 "KeyFile.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 61 "../src/Startup/Backend/KeyFile.vala"
	for (i = 0; i < stack_length; i++) {
#line 61 "../src/Startup/Backend/KeyFile.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 61 "../src/Startup/Backend/KeyFile.vala"
			return TRUE;
#line 1060 "KeyFile.c"
		}
	}
#line 61 "../src/Startup/Backend/KeyFile.vala"
	return FALSE;
#line 1065 "KeyFile.c"
}

gboolean
startup_backend_key_file_get_show (StartupBackendKeyFile* self)
{
	gboolean result;
	gchar** current_desktop = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint current_desktop_length1;
	gint _current_desktop_size_;
	gchar** only_show_in = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gint only_show_in_length1;
	gint _only_show_in_size_;
	gchar** not_show_in = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint not_show_in_length1;
	gint _not_show_in_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
#line 51 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "../src/Startup/Backend/KeyFile.vala"
	if (startup_backend_key_file_keyfile_get_bool (self, G_KEY_FILE_DESKTOP_KEY_NO_DISPLAY)) {
#line 53 "../src/Startup/Backend/KeyFile.vala"
		result = FALSE;
#line 53 "../src/Startup/Backend/KeyFile.vala"
		return result;
#line 1106 "KeyFile.c"
	}
#line 56 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 56 "../src/Startup/Backend/KeyFile.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ":", 0);
#line 56 "../src/Startup/Backend/KeyFile.vala"
	current_desktop = _tmp2_;
#line 56 "../src/Startup/Backend/KeyFile.vala"
	current_desktop_length1 = _vala_array_length (_tmp1_);
#line 56 "../src/Startup/Backend/KeyFile.vala"
	_current_desktop_size_ = current_desktop_length1;
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_tmp3_ = startup_backend_key_file_keyfile_get_string (self, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN);
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_tmp4_ = _tmp3_;
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ":", 0);
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_tmp7_ = _tmp6_;
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp4_);
#line 57 "../src/Startup/Backend/KeyFile.vala"
	only_show_in = _tmp7_;
#line 57 "../src/Startup/Backend/KeyFile.vala"
	only_show_in_length1 = _tmp7__length1;
#line 57 "../src/Startup/Backend/KeyFile.vala"
	_only_show_in_size_ = only_show_in_length1;
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_tmp8_ = startup_backend_key_file_keyfile_get_string (self, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN);
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_tmp9_ = _tmp8_;
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, ":", 0);
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_tmp12_ = _tmp11_;
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_tmp12__length1 = _vala_array_length (_tmp10_);
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (_tmp9_);
#line 58 "../src/Startup/Backend/KeyFile.vala"
	not_show_in = _tmp12_;
#line 58 "../src/Startup/Backend/KeyFile.vala"
	not_show_in_length1 = _tmp12__length1;
#line 58 "../src/Startup/Backend/KeyFile.vala"
	_not_show_in_size_ = not_show_in_length1;
#line 60 "../src/Startup/Backend/KeyFile.vala"
	_tmp13_ = current_desktop;
#line 60 "../src/Startup/Backend/KeyFile.vala"
	_tmp13__length1 = current_desktop_length1;
#line 1158 "KeyFile.c"
	{
		gchar** desktop_collection = NULL;
		gint desktop_collection_length1 = 0;
		gint _desktop_collection_size_ = 0;
		gint desktop_it = 0;
#line 60 "../src/Startup/Backend/KeyFile.vala"
		desktop_collection = _tmp13_;
#line 60 "../src/Startup/Backend/KeyFile.vala"
		desktop_collection_length1 = _tmp13__length1;
#line 60 "../src/Startup/Backend/KeyFile.vala"
		for (desktop_it = 0; desktop_it < desktop_collection_length1; desktop_it = desktop_it + 1) {
#line 1170 "KeyFile.c"
			const gchar* desktop = NULL;
#line 60 "../src/Startup/Backend/KeyFile.vala"
			desktop = desktop_collection[desktop_it];
#line 1174 "KeyFile.c"
			{
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar** _tmp17_;
				gint _tmp17__length1;
#line 61 "../src/Startup/Backend/KeyFile.vala"
				_tmp14_ = desktop;
#line 61 "../src/Startup/Backend/KeyFile.vala"
				_tmp15_ = only_show_in;
#line 61 "../src/Startup/Backend/KeyFile.vala"
				_tmp15__length1 = only_show_in_length1;
#line 61 "../src/Startup/Backend/KeyFile.vala"
				if (_vala_string_array_contains (_tmp15_, _tmp15__length1, _tmp14_)) {
#line 62 "../src/Startup/Backend/KeyFile.vala"
					result = TRUE;
#line 62 "../src/Startup/Backend/KeyFile.vala"
					not_show_in = (_vala_array_free (not_show_in, not_show_in_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/Startup/Backend/KeyFile.vala"
					only_show_in = (_vala_array_free (only_show_in, only_show_in_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/Startup/Backend/KeyFile.vala"
					current_desktop = (_vala_array_free (current_desktop, current_desktop_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/Startup/Backend/KeyFile.vala"
					return result;
#line 1200 "KeyFile.c"
				}
#line 65 "../src/Startup/Backend/KeyFile.vala"
				_tmp16_ = desktop;
#line 65 "../src/Startup/Backend/KeyFile.vala"
				_tmp17_ = not_show_in;
#line 65 "../src/Startup/Backend/KeyFile.vala"
				_tmp17__length1 = not_show_in_length1;
#line 65 "../src/Startup/Backend/KeyFile.vala"
				if (_vala_string_array_contains (_tmp17_, _tmp17__length1, _tmp16_)) {
#line 66 "../src/Startup/Backend/KeyFile.vala"
					result = FALSE;
#line 66 "../src/Startup/Backend/KeyFile.vala"
					not_show_in = (_vala_array_free (not_show_in, not_show_in_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/Startup/Backend/KeyFile.vala"
					only_show_in = (_vala_array_free (only_show_in, only_show_in_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/Startup/Backend/KeyFile.vala"
					current_desktop = (_vala_array_free (current_desktop, current_desktop_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/Startup/Backend/KeyFile.vala"
					return result;
#line 1220 "KeyFile.c"
				}
			}
		}
	}
#line 70 "../src/Startup/Backend/KeyFile.vala"
	result = !startup_backend_key_file_keyfile_has_key (self, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN);
#line 70 "../src/Startup/Backend/KeyFile.vala"
	not_show_in = (_vala_array_free (not_show_in, not_show_in_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/Startup/Backend/KeyFile.vala"
	only_show_in = (_vala_array_free (only_show_in, only_show_in_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/Startup/Backend/KeyFile.vala"
	current_desktop = (_vala_array_free (current_desktop, current_desktop_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 1235 "KeyFile.c"
}

const gchar*
startup_backend_key_file_get_path (StartupBackendKeyFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 74 "../src/Startup/Backend/KeyFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/Startup/Backend/KeyFile.vala"
	_tmp0_ = self->priv->_path;
#line 74 "../src/Startup/Backend/KeyFile.vala"
	result = _tmp0_;
#line 74 "../src/Startup/Backend/KeyFile.vala"
	return result;
#line 1251 "KeyFile.c"
}

void
startup_backend_key_file_set_path (StartupBackendKeyFile* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 74 "../src/Startup/Backend/KeyFile.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Startup/Backend/KeyFile.vala"
	old_value = startup_backend_key_file_get_path (self);
#line 74 "../src/Startup/Backend/KeyFile.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1265 "KeyFile.c"
		gchar* _tmp0_;
#line 74 "../src/Startup/Backend/KeyFile.vala"
		_tmp0_ = g_strdup (value);
#line 74 "../src/Startup/Backend/KeyFile.vala"
		_g_free0 (self->priv->_path);
#line 74 "../src/Startup/Backend/KeyFile.vala"
		self->priv->_path = _tmp0_;
#line 74 "../src/Startup/Backend/KeyFile.vala"
		g_object_notify_by_pspec ((GObject *) self, startup_backend_key_file_properties[STARTUP_BACKEND_KEY_FILE_PATH_PROPERTY]);
#line 1275 "KeyFile.c"
	}
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 81 "../src/Startup/Backend/KeyFile.vala"
	if (length >= 0) {
#line 1285 "KeyFile.c"
		gchar** result;
		gssize i;
#line 81 "../src/Startup/Backend/KeyFile.vala"
		result = g_new0 (gchar*, length + 1);
#line 81 "../src/Startup/Backend/KeyFile.vala"
		for (i = 0; i < length; i++) {
#line 1292 "KeyFile.c"
			gchar* _tmp0_;
#line 81 "../src/Startup/Backend/KeyFile.vala"
			_tmp0_ = g_strdup (self[i]);
#line 81 "../src/Startup/Backend/KeyFile.vala"
			result[i] = _tmp0_;
#line 1298 "KeyFile.c"
		}
#line 81 "../src/Startup/Backend/KeyFile.vala"
		return result;
#line 1302 "KeyFile.c"
	}
#line 81 "../src/Startup/Backend/KeyFile.vala"
	return NULL;
#line 1306 "KeyFile.c"
}

static void
startup_backend_key_file_class_init (StartupBackendKeyFileClass * klass,
                                     gpointer klass_data)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 27 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Startup/Backend/KeyFile.vala"
	g_type_class_adjust_private_offset (klass, &StartupBackendKeyFile_private_offset);
#line 27 "../src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_startup_backend_key_file_get_property;
#line 27 "../src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_startup_backend_key_file_set_property;
#line 27 "../src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_backend_key_file_finalize;
#line 27 "../src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_ACTIVE_PROPERTY, startup_backend_key_file_properties[STARTUP_BACKEND_KEY_FILE_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_SHOW_PROPERTY, startup_backend_key_file_properties[STARTUP_BACKEND_KEY_FILE_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/Startup/Backend/KeyFile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_BACKEND_KEY_FILE_PATH_PROPERTY, startup_backend_key_file_properties[STARTUP_BACKEND_KEY_FILE_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 81 "../src/Startup/Backend/KeyFile.vala"
	_tmp1_ = _tmp0_ = g_get_language_names ();
#line 81 "../src/Startup/Backend/KeyFile.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup2 (_tmp1_, _vala_array_length (_tmp0_)) : _tmp1_;
#line 81 "../src/Startup/Backend/KeyFile.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 81 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_languages = (_vala_array_free (startup_backend_key_file_languages, startup_backend_key_file_languages_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_languages = _tmp2_;
#line 81 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_languages_length1 = _tmp2__length1;
#line 81 "../src/Startup/Backend/KeyFile.vala"
	_startup_backend_key_file_languages_size_ = startup_backend_key_file_languages_length1;
#line 82 "../src/Startup/Backend/KeyFile.vala"
	_tmp3_ = startup_backend_key_file_languages;
#line 82 "../src/Startup/Backend/KeyFile.vala"
	_tmp3__length1 = startup_backend_key_file_languages_length1;
#line 82 "../src/Startup/Backend/KeyFile.vala"
	_tmp4_ = _tmp3_[0];
#line 82 "../src/Startup/Backend/KeyFile.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 82 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (startup_backend_key_file_preferred_language);
#line 82 "../src/Startup/Backend/KeyFile.vala"
	startup_backend_key_file_preferred_language = _tmp5_;
#line 1363 "KeyFile.c"
}

static void
startup_backend_key_file_instance_init (StartupBackendKeyFile * self,
                                        gpointer klass)
{
#line 27 "../src/Startup/Backend/KeyFile.vala"
	self->priv = startup_backend_key_file_get_instance_private (self);
#line 1372 "KeyFile.c"
}

static void
startup_backend_key_file_finalize (GObject * obj)
{
	StartupBackendKeyFile * self;
#line 27 "../src/Startup/Backend/KeyFile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile);
#line 74 "../src/Startup/Backend/KeyFile.vala"
	_g_free0 (self->priv->_path);
#line 76 "../src/Startup/Backend/KeyFile.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 27 "../src/Startup/Backend/KeyFile.vala"
	G_OBJECT_CLASS (startup_backend_key_file_parent_class)->finalize (obj);
#line 1387 "KeyFile.c"
}

/**
 * Stores information about an app found in it's .desktop file
 * and allows us to modify it.
 * http://standards.freedesktop.org/desktop-entry-spec/latest/index.html
 */
static GType
startup_backend_key_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StartupBackendKeyFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_backend_key_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupBackendKeyFile), 0, (GInstanceInitFunc) startup_backend_key_file_instance_init, NULL };
	GType startup_backend_key_file_type_id;
	startup_backend_key_file_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupBackendKeyFile", &g_define_type_info, 0);
	StartupBackendKeyFile_private_offset = g_type_add_instance_private (startup_backend_key_file_type_id, sizeof (StartupBackendKeyFilePrivate));
	return startup_backend_key_file_type_id;
}

GType
startup_backend_key_file_get_type (void)
{
	static volatile gsize startup_backend_key_file_type_id__once = 0;
	if (g_once_init_enter (&startup_backend_key_file_type_id__once)) {
		GType startup_backend_key_file_type_id;
		startup_backend_key_file_type_id = startup_backend_key_file_get_type_once ();
		g_once_init_leave (&startup_backend_key_file_type_id__once, startup_backend_key_file_type_id);
	}
	return startup_backend_key_file_type_id__once;
}

static void
_vala_startup_backend_key_file_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	StartupBackendKeyFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile);
#line 27 "../src/Startup/Backend/KeyFile.vala"
	switch (property_id) {
#line 27 "../src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_ACTIVE_PROPERTY:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		g_value_set_boolean (value, startup_backend_key_file_get_active (self));
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "../src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_SHOW_PROPERTY:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		g_value_set_boolean (value, startup_backend_key_file_get_show (self));
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "../src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_PATH_PROPERTY:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		g_value_set_string (value, startup_backend_key_file_get_path (self));
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 1445 "KeyFile.c"
		default:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 1451 "KeyFile.c"
	}
}

static void
_vala_startup_backend_key_file_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	StartupBackendKeyFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, STARTUP_BACKEND_TYPE_KEY_FILE, StartupBackendKeyFile);
#line 27 "../src/Startup/Backend/KeyFile.vala"
	switch (property_id) {
#line 27 "../src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_ACTIVE_PROPERTY:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_active (self, g_value_get_boolean (value));
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 27 "../src/Startup/Backend/KeyFile.vala"
		case STARTUP_BACKEND_KEY_FILE_PATH_PROPERTY:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		startup_backend_key_file_set_path (self, g_value_get_string (value));
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 1477 "KeyFile.c"
		default:
#line 27 "../src/Startup/Backend/KeyFile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Startup/Backend/KeyFile.vala"
		break;
#line 1483 "KeyFile.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

