/* Controller.c generated by valac 0.56.14, the Vala compiler
 * generated from Controller.vala, do not modify */

/*
* Copyright 2013-2017 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include "applications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include <gee.h>

#define STARTUP_CONTROLLER_APPLICATION_DIRS "applications"

enum  {
	STARTUP_CONTROLLER_0_PROPERTY,
	STARTUP_CONTROLLER_VIEW_PROPERTY,
	STARTUP_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* startup_controller_properties[STARTUP_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR (startup_backend_desktop_file_enumerator_get_type ())
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumerator))
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorClass))
#define STARTUP_BACKEND_IS_DESKTOP_FILE_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR))
#define STARTUP_BACKEND_IS_DESKTOP_FILE_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR))
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorClass))

typedef struct _StartupBackendDesktopFileEnumerator StartupBackendDesktopFileEnumerator;
typedef struct _StartupBackendDesktopFileEnumeratorClass StartupBackendDesktopFileEnumeratorClass;

struct _StartupControllerPrivate {
	StartupPlug* _view;
};

static gint StartupController_private_offset;
static gpointer startup_controller_parent_class = NULL;

static gchar** startup_controller_get_application_files (StartupController* self,
                                                  gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GType startup_backend_desktop_file_enumerator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN StartupBackendDesktopFileEnumerator* startup_backend_desktop_file_enumerator_new (gchar** dirs,
                                                                                  gint dirs_length1);
VALA_EXTERN StartupBackendDesktopFileEnumerator* startup_backend_desktop_file_enumerator_construct (GType object_type,
                                                                                        gchar** dirs,
                                                                                        gint dirs_length1);
VALA_EXTERN gchar** startup_backend_desktop_file_enumerator_get_desktop_files (StartupBackendDesktopFileEnumerator* self,
                                                                   gint* result_length1);
static gchar** startup_controller_get_auto_start_files (StartupController* self,
                                                 gint* result_length1);
static GObject * startup_controller_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
VALA_EXTERN StartupBackendKeyFile* startup_backend_key_file_factory_get_or_create (const gchar* path);
static void startup_controller_finalize (GObject * obj);
static GType startup_controller_get_type_once (void);
static void _vala_startup_controller_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_startup_controller_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
startup_controller_get_instance_private (StartupController* self)
{
	return G_STRUCT_MEMBER_P (self, StartupController_private_offset);
}

StartupController*
startup_controller_construct (GType object_type,
                              StartupPlug* view)
{
	StartupController * self = NULL;
#line 27 "../src/Startup/Controller.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 28 "../src/Startup/Controller.vala"
	self = (StartupController*) g_object_new (object_type, "view", view, NULL);
#line 27 "../src/Startup/Controller.vala"
	return self;
#line 123 "Controller.c"
}

StartupController*
startup_controller_new (StartupPlug* view)
{
#line 27 "../src/Startup/Controller.vala"
	return startup_controller_construct (STARTUP_TYPE_CONTROLLER, view);
#line 131 "Controller.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 53 "../src/Startup/Controller.vala"
	if (length >= 0) {
#line 140 "Controller.c"
		gchar** result;
		gssize i;
#line 53 "../src/Startup/Controller.vala"
		result = g_new0 (gchar*, length + 1);
#line 53 "../src/Startup/Controller.vala"
		for (i = 0; i < length; i++) {
#line 147 "Controller.c"
			gchar* _tmp0_;
#line 53 "../src/Startup/Controller.vala"
			_tmp0_ = g_strdup (self[i]);
#line 53 "../src/Startup/Controller.vala"
			result[i] = _tmp0_;
#line 153 "Controller.c"
		}
#line 53 "../src/Startup/Controller.vala"
		return result;
#line 157 "Controller.c"
	}
#line 53 "../src/Startup/Controller.vala"
	return NULL;
#line 161 "Controller.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 54 "../src/Startup/Controller.vala"
	if ((*length) == (*size)) {
#line 54 "../src/Startup/Controller.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 54 "../src/Startup/Controller.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 176 "Controller.c"
	}
#line 54 "../src/Startup/Controller.vala"
	(*array)[(*length)++] = value;
#line 54 "../src/Startup/Controller.vala"
	(*array)[*length] = NULL;
#line 182 "Controller.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 58 "../src/Startup/Controller.vala"
	if ((*length) == (*size)) {
#line 58 "../src/Startup/Controller.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 58 "../src/Startup/Controller.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 197 "Controller.c"
	}
#line 58 "../src/Startup/Controller.vala"
	(*array)[(*length)++] = value;
#line 58 "../src/Startup/Controller.vala"
	(*array)[*length] = NULL;
#line 203 "Controller.c"
}

static gchar**
startup_controller_get_application_files (StartupController* self,
                                          gint* result_length1)
{
	gchar** app_dirs = NULL;
	gchar** _tmp0_;
	gint app_dirs_length1;
	gint _app_dirs_size_;
	gchar** data_dirs = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint data_dirs_length1;
	gint _data_dirs_size_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
	StartupBackendDesktopFileEnumerator* enumerator = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	StartupBackendDesktopFileEnumerator* _tmp14_;
	gint _tmp15_ = 0;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar** result;
#line 50 "../src/Startup/Controller.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/Startup/Controller.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 51 "../src/Startup/Controller.vala"
	app_dirs = _tmp0_;
#line 51 "../src/Startup/Controller.vala"
	app_dirs_length1 = 0;
#line 51 "../src/Startup/Controller.vala"
	_app_dirs_size_ = app_dirs_length1;
#line 53 "../src/Startup/Controller.vala"
	_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
#line 53 "../src/Startup/Controller.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup1 (_tmp2_, _vala_array_length (_tmp1_)) : _tmp2_;
#line 53 "../src/Startup/Controller.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 53 "../src/Startup/Controller.vala"
	data_dirs = _tmp3_;
#line 53 "../src/Startup/Controller.vala"
	data_dirs_length1 = _tmp3__length1;
#line 53 "../src/Startup/Controller.vala"
	_data_dirs_size_ = data_dirs_length1;
#line 54 "../src/Startup/Controller.vala"
	_tmp4_ = g_get_user_data_dir ();
#line 54 "../src/Startup/Controller.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 54 "../src/Startup/Controller.vala"
	_vala_array_add1 (&data_dirs, &data_dirs_length1, &_data_dirs_size_, _tmp5_);
#line 55 "../src/Startup/Controller.vala"
	_tmp6_ = data_dirs;
#line 55 "../src/Startup/Controller.vala"
	_tmp6__length1 = data_dirs_length1;
#line 268 "Controller.c"
	{
		gchar** data_dir_collection = NULL;
		gint data_dir_collection_length1 = 0;
		gint _data_dir_collection_size_ = 0;
		gint data_dir_it = 0;
#line 55 "../src/Startup/Controller.vala"
		data_dir_collection = _tmp6_;
#line 55 "../src/Startup/Controller.vala"
		data_dir_collection_length1 = _tmp6__length1;
#line 55 "../src/Startup/Controller.vala"
		for (data_dir_it = 0; data_dir_it < data_dir_collection_length1; data_dir_it = data_dir_it + 1) {
#line 280 "Controller.c"
			const gchar* data_dir = NULL;
#line 55 "../src/Startup/Controller.vala"
			data_dir = data_dir_collection[data_dir_it];
#line 284 "Controller.c"
			{
				gchar* app_dir = NULL;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
#line 56 "../src/Startup/Controller.vala"
				_tmp7_ = data_dir;
#line 56 "../src/Startup/Controller.vala"
				_tmp8_ = g_build_filename (_tmp7_, STARTUP_CONTROLLER_APPLICATION_DIRS, NULL);
#line 56 "../src/Startup/Controller.vala"
				app_dir = _tmp8_;
#line 57 "../src/Startup/Controller.vala"
				_tmp9_ = app_dir;
#line 57 "../src/Startup/Controller.vala"
				if (g_file_test (_tmp9_, G_FILE_TEST_EXISTS)) {
#line 300 "Controller.c"
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 58 "../src/Startup/Controller.vala"
					_tmp10_ = app_dir;
#line 58 "../src/Startup/Controller.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 58 "../src/Startup/Controller.vala"
					_vala_array_add2 (&app_dirs, &app_dirs_length1, &_app_dirs_size_, _tmp11_);
#line 309 "Controller.c"
				}
#line 55 "../src/Startup/Controller.vala"
				_g_free0 (app_dir);
#line 313 "Controller.c"
			}
		}
	}
#line 62 "../src/Startup/Controller.vala"
	_tmp12_ = app_dirs;
#line 62 "../src/Startup/Controller.vala"
	_tmp12__length1 = app_dirs_length1;
#line 62 "../src/Startup/Controller.vala"
	if (_tmp12__length1 == 0) {
#line 63 "../src/Startup/Controller.vala"
		g_warning ("Controller.vala:63: No application directories found");
#line 325 "Controller.c"
	}
#line 66 "../src/Startup/Controller.vala"
	_tmp13_ = app_dirs;
#line 66 "../src/Startup/Controller.vala"
	_tmp13__length1 = app_dirs_length1;
#line 66 "../src/Startup/Controller.vala"
	_tmp14_ = startup_backend_desktop_file_enumerator_new (_tmp13_, _tmp13__length1);
#line 66 "../src/Startup/Controller.vala"
	enumerator = _tmp14_;
#line 67 "../src/Startup/Controller.vala"
	_tmp16_ = startup_backend_desktop_file_enumerator_get_desktop_files (enumerator, &_tmp15_);
#line 67 "../src/Startup/Controller.vala"
	_tmp17_ = _tmp16_;
#line 67 "../src/Startup/Controller.vala"
	_tmp17__length1 = _tmp15_;
#line 67 "../src/Startup/Controller.vala"
	if (result_length1) {
#line 67 "../src/Startup/Controller.vala"
		*result_length1 = _tmp17__length1;
#line 345 "Controller.c"
	}
#line 67 "../src/Startup/Controller.vala"
	result = _tmp17_;
#line 67 "../src/Startup/Controller.vala"
	_g_object_unref0 (enumerator);
#line 67 "../src/Startup/Controller.vala"
	data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_free), NULL);
#line 67 "../src/Startup/Controller.vala"
	app_dirs = (_vala_array_free (app_dirs, app_dirs_length1, (GDestroyNotify) g_free), NULL);
#line 67 "../src/Startup/Controller.vala"
	return result;
#line 357 "Controller.c"
}

static gchar**
startup_controller_get_auto_start_files (StartupController* self,
                                         gint* result_length1)
{
	gchar* startup_dir = NULL;
	gchar* _tmp0_;
	StartupBackendDesktopFileEnumerator* enumerator = NULL;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	StartupBackendDesktopFileEnumerator* _tmp4_;
	StartupBackendDesktopFileEnumerator* _tmp5_;
	gint _tmp6_ = 0;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result;
#line 70 "../src/Startup/Controller.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Startup/Controller.vala"
	_tmp0_ = startup_utils_get_user_startup_dir ();
#line 71 "../src/Startup/Controller.vala"
	startup_dir = _tmp0_;
#line 72 "../src/Startup/Controller.vala"
	_tmp1_ = g_strdup (startup_dir);
#line 72 "../src/Startup/Controller.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 72 "../src/Startup/Controller.vala"
	_tmp2_[0] = _tmp1_;
#line 72 "../src/Startup/Controller.vala"
	_tmp3_ = _tmp2_;
#line 72 "../src/Startup/Controller.vala"
	_tmp3__length1 = 1;
#line 72 "../src/Startup/Controller.vala"
	_tmp4_ = startup_backend_desktop_file_enumerator_new (_tmp3_, 1);
#line 72 "../src/Startup/Controller.vala"
	_tmp5_ = _tmp4_;
#line 72 "../src/Startup/Controller.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/Startup/Controller.vala"
	enumerator = _tmp5_;
#line 73 "../src/Startup/Controller.vala"
	_tmp7_ = startup_backend_desktop_file_enumerator_get_desktop_files (enumerator, &_tmp6_);
#line 73 "../src/Startup/Controller.vala"
	_tmp8_ = _tmp7_;
#line 73 "../src/Startup/Controller.vala"
	_tmp8__length1 = _tmp6_;
#line 73 "../src/Startup/Controller.vala"
	if (result_length1) {
#line 73 "../src/Startup/Controller.vala"
		*result_length1 = _tmp8__length1;
#line 412 "Controller.c"
	}
#line 73 "../src/Startup/Controller.vala"
	result = _tmp8_;
#line 73 "../src/Startup/Controller.vala"
	_g_object_unref0 (enumerator);
#line 73 "../src/Startup/Controller.vala"
	_g_free0 (startup_dir);
#line 73 "../src/Startup/Controller.vala"
	return result;
#line 422 "Controller.c"
}

StartupPlug*
startup_controller_get_view (StartupController* self)
{
	StartupPlug* result;
	StartupPlug* _tmp0_;
#line 23 "../src/Startup/Controller.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Startup/Controller.vala"
	_tmp0_ = self->priv->_view;
#line 23 "../src/Startup/Controller.vala"
	result = _tmp0_;
#line 23 "../src/Startup/Controller.vala"
	return result;
#line 438 "Controller.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/Startup/Controller.vala"
	return self ? g_object_ref (self) : NULL;
#line 446 "Controller.c"
}

static void
startup_controller_set_view (StartupController* self,
                             StartupPlug* value)
{
	StartupPlug* old_value;
#line 23 "../src/Startup/Controller.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Startup/Controller.vala"
	old_value = startup_controller_get_view (self);
#line 23 "../src/Startup/Controller.vala"
	if (old_value != value) {
#line 460 "Controller.c"
		StartupPlug* _tmp0_;
#line 23 "../src/Startup/Controller.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Startup/Controller.vala"
		_g_object_unref0 (self->priv->_view);
#line 23 "../src/Startup/Controller.vala"
		self->priv->_view = _tmp0_;
#line 23 "../src/Startup/Controller.vala"
		g_object_notify_by_pspec ((GObject *) self, startup_controller_properties[STARTUP_CONTROLLER_VIEW_PROPERTY]);
#line 470 "Controller.c"
	}
}

static GObject *
startup_controller_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	StartupController * self;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	GeeArrayList* app_infos = NULL;
	GeeArrayList* _tmp9_;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	StartupPlug* _tmp22_;
	GeeArrayList* _tmp23_;
#line 31 "../src/Startup/Controller.vala"
	parent_class = G_OBJECT_CLASS (startup_controller_parent_class);
#line 31 "../src/Startup/Controller.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Startup/Controller.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_CONTROLLER, StartupController);
#line 32 "../src/Startup/Controller.vala"
	_tmp1_ = startup_controller_get_auto_start_files (self, &_tmp0_);
#line 498 "Controller.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 32 "../src/Startup/Controller.vala"
		path_collection = _tmp1_;
#line 32 "../src/Startup/Controller.vala"
		path_collection_length1 = _tmp0_;
#line 32 "../src/Startup/Controller.vala"
		for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 510 "Controller.c"
			const gchar* path = NULL;
#line 32 "../src/Startup/Controller.vala"
			path = path_collection[path_it];
#line 514 "Controller.c"
			{
				StartupBackendKeyFile* key_file = NULL;
				const gchar* _tmp2_;
				StartupBackendKeyFile* _tmp3_;
				StartupBackendKeyFile* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
#line 33 "../src/Startup/Controller.vala"
				_tmp2_ = path;
#line 33 "../src/Startup/Controller.vala"
				_tmp3_ = startup_backend_key_file_factory_get_or_create (_tmp2_);
#line 33 "../src/Startup/Controller.vala"
				key_file = _tmp3_;
#line 34 "../src/Startup/Controller.vala"
				_tmp4_ = key_file;
#line 34 "../src/Startup/Controller.vala"
				_tmp5_ = startup_backend_key_file_get_show (_tmp4_);
#line 34 "../src/Startup/Controller.vala"
				_tmp6_ = _tmp5_;
#line 34 "../src/Startup/Controller.vala"
				if (_tmp6_) {
#line 536 "Controller.c"
					StartupPlug* _tmp7_;
					StartupBackendKeyFile* _tmp8_;
#line 35 "../src/Startup/Controller.vala"
					_tmp7_ = self->priv->_view;
#line 35 "../src/Startup/Controller.vala"
					_tmp8_ = key_file;
#line 35 "../src/Startup/Controller.vala"
					startup_plug_add_app (_tmp7_, _tmp8_);
#line 545 "Controller.c"
				}
#line 32 "../src/Startup/Controller.vala"
				_g_object_unref0 (key_file);
#line 549 "Controller.c"
			}
		}
#line 32 "../src/Startup/Controller.vala"
		path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
#line 554 "Controller.c"
	}
#line 39 "../src/Startup/Controller.vala"
	_tmp9_ = gee_array_list_new (STARTUP_ENTITY_TYPE_APP_INFO, (GBoxedCopyFunc) startup_entity_app_info_dup, (GDestroyNotify) startup_entity_app_info_free, NULL, NULL, NULL);
#line 39 "../src/Startup/Controller.vala"
	app_infos = _tmp9_;
#line 40 "../src/Startup/Controller.vala"
	_tmp11_ = startup_controller_get_application_files (self, &_tmp10_);
#line 562 "Controller.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 40 "../src/Startup/Controller.vala"
		path_collection = _tmp11_;
#line 40 "../src/Startup/Controller.vala"
		path_collection_length1 = _tmp10_;
#line 40 "../src/Startup/Controller.vala"
		for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 574 "Controller.c"
			const gchar* path = NULL;
#line 40 "../src/Startup/Controller.vala"
			path = path_collection[path_it];
#line 578 "Controller.c"
			{
				StartupBackendKeyFile* key_file = NULL;
				const gchar* _tmp12_;
				StartupBackendKeyFile* _tmp13_;
				StartupBackendKeyFile* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
#line 41 "../src/Startup/Controller.vala"
				_tmp12_ = path;
#line 41 "../src/Startup/Controller.vala"
				_tmp13_ = startup_backend_key_file_factory_get_or_create (_tmp12_);
#line 41 "../src/Startup/Controller.vala"
				key_file = _tmp13_;
#line 42 "../src/Startup/Controller.vala"
				_tmp14_ = key_file;
#line 42 "../src/Startup/Controller.vala"
				_tmp15_ = startup_backend_key_file_get_show (_tmp14_);
#line 42 "../src/Startup/Controller.vala"
				_tmp16_ = _tmp15_;
#line 42 "../src/Startup/Controller.vala"
				if (_tmp16_) {
#line 600 "Controller.c"
					GeeArrayList* _tmp17_;
					StartupBackendKeyFile* _tmp18_;
					StartupEntityAppInfo _tmp19_ = {0};
					StartupEntityAppInfo _tmp20_;
					StartupEntityAppInfo _tmp21_;
#line 43 "../src/Startup/Controller.vala"
					_tmp17_ = app_infos;
#line 43 "../src/Startup/Controller.vala"
					_tmp18_ = key_file;
#line 43 "../src/Startup/Controller.vala"
					startup_backend_key_file_create_app_info (_tmp18_, &_tmp19_);
#line 43 "../src/Startup/Controller.vala"
					_tmp20_ = _tmp19_;
#line 43 "../src/Startup/Controller.vala"
					_tmp21_ = _tmp20_;
#line 43 "../src/Startup/Controller.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, &_tmp21_);
#line 43 "../src/Startup/Controller.vala"
					startup_entity_app_info_destroy (&_tmp20_);
#line 620 "Controller.c"
				}
#line 40 "../src/Startup/Controller.vala"
				_g_object_unref0 (key_file);
#line 624 "Controller.c"
			}
		}
#line 40 "../src/Startup/Controller.vala"
		path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
#line 629 "Controller.c"
	}
#line 47 "../src/Startup/Controller.vala"
	_tmp22_ = self->priv->_view;
#line 47 "../src/Startup/Controller.vala"
	_tmp23_ = app_infos;
#line 47 "../src/Startup/Controller.vala"
	startup_plug_init_app_chooser (_tmp22_, (GeeCollection*) _tmp23_);
#line 31 "../src/Startup/Controller.vala"
	_g_object_unref0 (app_infos);
#line 31 "../src/Startup/Controller.vala"
	return obj;
#line 641 "Controller.c"
}

static void
startup_controller_class_init (StartupControllerClass * klass,
                               gpointer klass_data)
{
#line 22 "../src/Startup/Controller.vala"
	startup_controller_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Startup/Controller.vala"
	g_type_class_adjust_private_offset (klass, &StartupController_private_offset);
#line 22 "../src/Startup/Controller.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_startup_controller_get_property;
#line 22 "../src/Startup/Controller.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_startup_controller_set_property;
#line 22 "../src/Startup/Controller.vala"
	G_OBJECT_CLASS (klass)->constructor = startup_controller_constructor;
#line 22 "../src/Startup/Controller.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_controller_finalize;
#line 22 "../src/Startup/Controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), STARTUP_CONTROLLER_VIEW_PROPERTY, startup_controller_properties[STARTUP_CONTROLLER_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", STARTUP_TYPE_PLUG, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 662 "Controller.c"
}

static void
startup_controller_instance_init (StartupController * self,
                                  gpointer klass)
{
#line 22 "../src/Startup/Controller.vala"
	self->priv = startup_controller_get_instance_private (self);
#line 671 "Controller.c"
}

static void
startup_controller_finalize (GObject * obj)
{
	StartupController * self;
#line 22 "../src/Startup/Controller.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_CONTROLLER, StartupController);
#line 23 "../src/Startup/Controller.vala"
	_g_object_unref0 (self->priv->_view);
#line 22 "../src/Startup/Controller.vala"
	G_OBJECT_CLASS (startup_controller_parent_class)->finalize (obj);
#line 684 "Controller.c"
}

static GType
startup_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StartupControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupController), 0, (GInstanceInitFunc) startup_controller_instance_init, NULL };
	GType startup_controller_type_id;
	startup_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupController", &g_define_type_info, 0);
	StartupController_private_offset = g_type_add_instance_private (startup_controller_type_id, sizeof (StartupControllerPrivate));
	return startup_controller_type_id;
}

GType
startup_controller_get_type (void)
{
	static volatile gsize startup_controller_type_id__once = 0;
	if (g_once_init_enter (&startup_controller_type_id__once)) {
		GType startup_controller_type_id;
		startup_controller_type_id = startup_controller_get_type_once ();
		g_once_init_leave (&startup_controller_type_id__once, startup_controller_type_id);
	}
	return startup_controller_type_id__once;
}

static void
_vala_startup_controller_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	StartupController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, STARTUP_TYPE_CONTROLLER, StartupController);
#line 22 "../src/Startup/Controller.vala"
	switch (property_id) {
#line 22 "../src/Startup/Controller.vala"
		case STARTUP_CONTROLLER_VIEW_PROPERTY:
#line 22 "../src/Startup/Controller.vala"
		g_value_set_object (value, startup_controller_get_view (self));
#line 22 "../src/Startup/Controller.vala"
		break;
#line 725 "Controller.c"
		default:
#line 22 "../src/Startup/Controller.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Startup/Controller.vala"
		break;
#line 731 "Controller.c"
	}
}

static void
_vala_startup_controller_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	StartupController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, STARTUP_TYPE_CONTROLLER, StartupController);
#line 22 "../src/Startup/Controller.vala"
	switch (property_id) {
#line 22 "../src/Startup/Controller.vala"
		case STARTUP_CONTROLLER_VIEW_PROPERTY:
#line 22 "../src/Startup/Controller.vala"
		startup_controller_set_view (self, g_value_get_object (value));
#line 22 "../src/Startup/Controller.vala"
		break;
#line 751 "Controller.c"
		default:
#line 22 "../src/Startup/Controller.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Startup/Controller.vala"
		break;
#line 757 "Controller.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

