/* Utils.c generated by valac 0.56.14, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright 2013-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "applications.h"
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define STARTUP_UTILS_AUTOSTART_DIR "autostart"
#define STARTUP_UTILS_FALLBACK_ICON "application-default-icon"

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

gchar*
startup_utils_get_user_startup_dir (void)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* startup_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 26 "../src/Startup/Utils.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 26 "../src/Startup/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 26 "../src/Startup/Utils.vala"
	config_dir = _tmp1_;
#line 27 "../src/Startup/Utils.vala"
	_tmp2_ = config_dir;
#line 27 "../src/Startup/Utils.vala"
	_tmp3_ = g_build_filename (_tmp2_, STARTUP_UTILS_AUTOSTART_DIR, NULL);
#line 27 "../src/Startup/Utils.vala"
	startup_dir = _tmp3_;
#line 29 "../src/Startup/Utils.vala"
	_tmp4_ = startup_dir;
#line 29 "../src/Startup/Utils.vala"
	if (g_file_test (_tmp4_, G_FILE_TEST_EXISTS) == FALSE) {
#line 70 "Utils.c"
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
#line 30 "../src/Startup/Utils.vala"
		_tmp5_ = startup_dir;
#line 30 "../src/Startup/Utils.vala"
		_tmp6_ = g_file_new_for_path (_tmp5_);
#line 30 "../src/Startup/Utils.vala"
		file = _tmp6_;
#line 80 "Utils.c"
		{
			GFile* _tmp7_;
#line 33 "../src/Startup/Utils.vala"
			_tmp7_ = file;
#line 33 "../src/Startup/Utils.vala"
			g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
#line 33 "../src/Startup/Utils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "Utils.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 32 "../src/Startup/Utils.vala"
			e = _inner_error0_;
#line 32 "../src/Startup/Utils.vala"
			_inner_error0_ = NULL;
#line 35 "../src/Startup/Utils.vala"
			_tmp8_ = e;
#line 35 "../src/Startup/Utils.vala"
			_tmp9_ = _tmp8_->message;
#line 35 "../src/Startup/Utils.vala"
			g_warning ("Utils.vala:35: %s", _tmp9_);
#line 32 "../src/Startup/Utils.vala"
			_g_error_free0 (e);
#line 111 "Utils.c"
		}
		__finally0:
#line 32 "../src/Startup/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../src/Startup/Utils.vala"
			_g_object_unref0 (file);
#line 32 "../src/Startup/Utils.vala"
			_g_free0 (startup_dir);
#line 32 "../src/Startup/Utils.vala"
			_g_free0 (config_dir);
#line 32 "../src/Startup/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 32 "../src/Startup/Utils.vala"
			g_clear_error (&_inner_error0_);
#line 32 "../src/Startup/Utils.vala"
			return NULL;
#line 128 "Utils.c"
		}
#line 29 "../src/Startup/Utils.vala"
		_g_object_unref0 (file);
#line 132 "Utils.c"
	}
#line 39 "../src/Startup/Utils.vala"
	result = startup_dir;
#line 39 "../src/Startup/Utils.vala"
	_g_free0 (config_dir);
#line 39 "../src/Startup/Utils.vala"
	return result;
#line 140 "Utils.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 159 "Utils.c"
}

gboolean
startup_utils_is_desktop_file (const gchar* name)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 42 "../src/Startup/Utils.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 43 "../src/Startup/Utils.vala"
	if (!string_contains (name, "~")) {
#line 43 "../src/Startup/Utils.vala"
		_tmp0_ = g_str_has_suffix (name, ".desktop");
#line 173 "Utils.c"
	} else {
#line 43 "../src/Startup/Utils.vala"
		_tmp0_ = FALSE;
#line 177 "Utils.c"
	}
#line 43 "../src/Startup/Utils.vala"
	result = _tmp0_;
#line 43 "../src/Startup/Utils.vala"
	return result;
#line 183 "Utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/Startup/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 191 "Utils.c"
}

GtkImage*
startup_utils_create_icon (StartupEntityAppInfo* app_info,
                           GtkIconSize icon_size)
{
	GThemedIcon* icon = NULL;
	StartupEntityAppInfo _tmp0_;
	const gchar* _tmp1_;
	GThemedIcon* _tmp2_;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp3_;
	GtkIconTheme* _tmp4_;
	gint pixel_size = 0;
	GtkImage* image = NULL;
	GtkImage* _tmp5_;
	GtkIconTheme* _tmp6_;
	GThemedIcon* _tmp7_;
	GtkIconInfo* _tmp8_;
	GtkIconInfo* _tmp9_;
	gboolean _tmp10_;
	GtkImage* _tmp25_;
	GError* _inner_error0_ = NULL;
	GtkImage* result;
#line 48 "../src/Startup/Utils.vala"
	g_return_val_if_fail (app_info != NULL, NULL);
#line 49 "../src/Startup/Utils.vala"
	_tmp0_ = *app_info;
#line 49 "../src/Startup/Utils.vala"
	_tmp1_ = _tmp0_.icon;
#line 49 "../src/Startup/Utils.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (_tmp1_);
#line 49 "../src/Startup/Utils.vala"
	icon = _tmp2_;
#line 50 "../src/Startup/Utils.vala"
	_tmp3_ = gtk_icon_theme_get_default ();
#line 50 "../src/Startup/Utils.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 50 "../src/Startup/Utils.vala"
	icon_theme = _tmp4_;
#line 54 "../src/Startup/Utils.vala"
	switch (icon_size) {
#line 54 "../src/Startup/Utils.vala"
		case GTK_ICON_SIZE_DIALOG:
#line 236 "Utils.c"
		{
#line 56 "../src/Startup/Utils.vala"
			pixel_size = 48;
#line 57 "../src/Startup/Utils.vala"
			break;
#line 242 "Utils.c"
		}
#line 54 "../src/Startup/Utils.vala"
		case GTK_ICON_SIZE_DND:
#line 246 "Utils.c"
		{
#line 59 "../src/Startup/Utils.vala"
			pixel_size = 32;
#line 60 "../src/Startup/Utils.vala"
			break;
#line 252 "Utils.c"
		}
		default:
		{
#line 62 "../src/Startup/Utils.vala"
			pixel_size = 32;
#line 63 "../src/Startup/Utils.vala"
			break;
#line 260 "Utils.c"
		}
	}
#line 66 "../src/Startup/Utils.vala"
	_tmp5_ = (GtkImage*) gtk_image_new ();
#line 66 "../src/Startup/Utils.vala"
	g_object_ref_sink (_tmp5_);
#line 66 "../src/Startup/Utils.vala"
	image = _tmp5_;
#line 68 "../src/Startup/Utils.vala"
	_tmp6_ = icon_theme;
#line 68 "../src/Startup/Utils.vala"
	_tmp7_ = icon;
#line 68 "../src/Startup/Utils.vala"
	_tmp8_ = gtk_icon_theme_lookup_by_gicon (_tmp6_, (GIcon*) _tmp7_, pixel_size, GTK_ICON_LOOKUP_USE_BUILTIN);
#line 68 "../src/Startup/Utils.vala"
	_tmp9_ = _tmp8_;
#line 68 "../src/Startup/Utils.vala"
	_tmp10_ = _tmp9_ == NULL;
#line 68 "../src/Startup/Utils.vala"
	_g_object_unref0 (_tmp9_);
#line 68 "../src/Startup/Utils.vala"
	if (_tmp10_) {
#line 283 "Utils.c"
		{
			GdkPixbuf* _tmp11_ = NULL;
			StartupEntityAppInfo _tmp12_;
			const gchar* _tmp13_;
			GdkPixbuf* _tmp14_;
			GdkPixbuf* pixbuf = NULL;
			GdkPixbuf* _tmp15_;
			GdkPixbuf* _tmp16_;
			GtkImage* _tmp17_;
#line 70 "../src/Startup/Utils.vala"
			_tmp12_ = *app_info;
#line 70 "../src/Startup/Utils.vala"
			_tmp13_ = _tmp12_.icon;
#line 70 "../src/Startup/Utils.vala"
			_tmp14_ = gdk_pixbuf_new_from_file (_tmp13_, &_inner_error0_);
#line 70 "../src/Startup/Utils.vala"
			_tmp11_ = _tmp14_;
#line 70 "../src/Startup/Utils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 303 "Utils.c"
				goto __catch0_g_error;
			}
#line 70 "../src/Startup/Utils.vala"
			_tmp15_ = gdk_pixbuf_scale_simple (_tmp11_, pixel_size, pixel_size, GDK_INTERP_BILINEAR);
#line 70 "../src/Startup/Utils.vala"
			pixbuf = _tmp15_;
#line 72 "../src/Startup/Utils.vala"
			_tmp16_ = pixbuf;
#line 72 "../src/Startup/Utils.vala"
			_tmp17_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp16_);
#line 72 "../src/Startup/Utils.vala"
			g_object_ref_sink (_tmp17_);
#line 72 "../src/Startup/Utils.vala"
			_g_object_unref0 (image);
#line 72 "../src/Startup/Utils.vala"
			image = _tmp17_;
#line 69 "../src/Startup/Utils.vala"
			_g_object_unref0 (pixbuf);
#line 69 "../src/Startup/Utils.vala"
			_g_object_unref0 (_tmp11_);
#line 324 "Utils.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GThemedIcon* _tmp18_;
			GThemedIcon* _tmp19_;
			GtkImage* _tmp20_;
			GError* _tmp21_;
			const gchar* _tmp22_;
#line 69 "../src/Startup/Utils.vala"
			err = _inner_error0_;
#line 69 "../src/Startup/Utils.vala"
			_inner_error0_ = NULL;
#line 74 "../src/Startup/Utils.vala"
			_tmp18_ = (GThemedIcon*) g_themed_icon_new (STARTUP_UTILS_FALLBACK_ICON);
#line 74 "../src/Startup/Utils.vala"
			_g_object_unref0 (icon);
#line 74 "../src/Startup/Utils.vala"
			icon = _tmp18_;
#line 75 "../src/Startup/Utils.vala"
			_tmp19_ = icon;
#line 75 "../src/Startup/Utils.vala"
			_tmp20_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp19_, (GtkIconSize) icon_size);
#line 75 "../src/Startup/Utils.vala"
			g_object_ref_sink (_tmp20_);
#line 75 "../src/Startup/Utils.vala"
			_g_object_unref0 (image);
#line 75 "../src/Startup/Utils.vala"
			image = _tmp20_;
#line 76 "../src/Startup/Utils.vala"
			_tmp21_ = err;
#line 76 "../src/Startup/Utils.vala"
			_tmp22_ = _tmp21_->message;
#line 76 "../src/Startup/Utils.vala"
			g_debug ("Utils.vala:76: %s", _tmp22_);
#line 69 "../src/Startup/Utils.vala"
			_g_error_free0 (err);
#line 363 "Utils.c"
		}
		__finally0:
#line 69 "../src/Startup/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/Startup/Utils.vala"
			_g_object_unref0 (image);
#line 69 "../src/Startup/Utils.vala"
			_g_object_unref0 (icon_theme);
#line 69 "../src/Startup/Utils.vala"
			_g_object_unref0 (icon);
#line 69 "../src/Startup/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/Startup/Utils.vala"
			g_clear_error (&_inner_error0_);
#line 69 "../src/Startup/Utils.vala"
			return NULL;
#line 380 "Utils.c"
		}
	} else {
		GThemedIcon* _tmp23_;
		GtkImage* _tmp24_;
#line 79 "../src/Startup/Utils.vala"
		_tmp23_ = icon;
#line 79 "../src/Startup/Utils.vala"
		_tmp24_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp23_, (GtkIconSize) icon_size);
#line 79 "../src/Startup/Utils.vala"
		g_object_ref_sink (_tmp24_);
#line 79 "../src/Startup/Utils.vala"
		_g_object_unref0 (image);
#line 79 "../src/Startup/Utils.vala"
		image = _tmp24_;
#line 395 "Utils.c"
	}
#line 82 "../src/Startup/Utils.vala"
	_tmp25_ = image;
#line 82 "../src/Startup/Utils.vala"
	gtk_image_set_pixel_size (_tmp25_, pixel_size);
#line 84 "../src/Startup/Utils.vala"
	result = image;
#line 84 "../src/Startup/Utils.vala"
	_g_object_unref0 (icon_theme);
#line 84 "../src/Startup/Utils.vala"
	_g_object_unref0 (icon);
#line 84 "../src/Startup/Utils.vala"
	return result;
#line 409 "Utils.c"
}

